// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
// AmorsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Amors.h"
#include "AmorsDlg.h"
#include "TestDlg.h"
#include "NewConfigDlg.h"
#include <string>
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAmorsDlg dialog

CAmorsDlg::CAmorsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAmorsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAmorsDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_iRepStage=-1;
	m_fRepProgress=0;
	m_yInPerf=FALSE;
	m_hAcqLib=NULL,
	m_hDispLib=NULL,
	m_hDataBaseLib=NULL,
	m_hObjSepLib=NULL,
	ZeroMemory(&m_ProcAddresses,sizeof(tagSJProcAddresses));
	m_yAbort=FALSE;
	m_iMode=ML_NORMAL_MODE;
}

void CAmorsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAmorsDlg)
	DDX_Control(pDX, IDC_START_UP_LB_LOG, m_ctrlLBLog);
	DDX_Control(pDX, IDC_START_UP_BTN_CONFIGURE, m_ctrlBtnConfigure);
	DDX_Control(pDX, IDC_START_UP_BTN_BROWSE, m_ctrlBtnBrowse);
	DDX_Control(pDX, IDC_START_UP_BTN_DISPLAY_LAST, m_ctrlBtnDispLast);
	DDX_Control(pDX, IDC_START_UP_BTN_CLOSE, m_ctrlBtnClose);
	DDX_Control(pDX, IDC_START_UP_BTN_TEST, m_ctrlBtnTest);
	DDX_Control(pDX, IDC_START_UP_BTN_RESEARCH_MODE, m_ctrlBtnResearch);
	DDX_Control(pDX, IDC_START_UP_BTN_LUNCH_CONFIG, m_ctrlBtnLunch);
	DDX_Control(pDX, IDC_START_UP_STATIC_PROGRESS_LABLE, m_ctrlProgressLable);
	DDX_Control(pDX, IDC_START_UP_PROGRESS, m_ctrlPorgress);
	DDX_Control(pDX, IDC_START_UP_EDIT_CONFIG_NAME, m_eConfigName);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAmorsDlg, CDialog)
	//{{AFX_MSG_MAP(CAmorsDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START_UP_BTN_CLOSE, OnStartUpBtnClose)
	ON_BN_CLICKED(IDC_START_UP_BTN_TEST, OnStartUpBtnTest)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_START_UP_BTN_LUNCH_CONFIG, OnStartUpBtnLunchConfig)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_START_UP_BTN_RESEARCH_MODE, OnStartUpBtnResearchMode)
	ON_BN_CLICKED(IDC_START_UP_BTN_DISPLAY_LAST, OnStartUpBtnDisplayLast)
	ON_BN_CLICKED(IDC_START_UP_BTN_BROWSE, OnStartUpBtnBrowse)
	ON_BN_CLICKED(IDC_START_UP_BTN_CONFIGURE, OnStartUpBtnConfigure)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAmorsDlg message handlers
BOOL CAmorsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Use only folder where executable is_instance_of
	m_Preferences.SetPath(MakeAbsolute(Preferences_ini_file,GetRootDir(),false));
	ApplyPref();
	m_ctrlLBLog.AddString(m_Preferences.GetPath().data());
	//m_ctrlLBLog.AddString(argv[0]);
	m_ctrlPorgress.SetStep(10);
	m_ctrlPorgress.SetRange(0,100);
	m_ctrlPorgress.SetPos(0);
	m_uTimerID = SetTimer(0x451, 100, NULL);
	CRect tRect;
	GetWindowRect(tRect);
	MoveWindow(10,10,tRect.Width(),tRect.Height());
	//exit(0);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAmorsDlg::ApplyPref()
{
	m_Preferences.ReadFile();
	std::string str=m_Preferences.GetValue("General","Last_Config");
	if(FileExists(str))m_eConfigName.SetWindowText(str.data());
}

void CAmorsDlg::SavePref()
{
	CString str="";
	std::string strHelp;
	m_eConfigName.GetWindowText(str);
	strHelp=str.GetBuffer(str.GetLength());
	m_Preferences.SetValue("General","Last_Config",strHelp);
	m_Preferences.WriteFile();
}

void CAmorsDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAmorsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAmorsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



void CAmorsDlg::OnStartUpBtnClose() 
{
	if(m_yInPerf)
	{
		m_yAbort=true;
		m_Specimen.AddLogMessage("User aborts the execution");
	}
	else
	{
		KillTimer(m_uTimerID);
		SavePref();	
		EndDialog(SJ_NORMAL_EXIT);//exit(SJ_NORMAL_EXIT);
	}
}

void CAmorsDlg::OnStartUpBtnTest() 
{
	CTestDlg aDlg;
	aDlg.DoModal();
}

void CAmorsDlg::OnClose() 
{
	CDialog::OnClose();
}

BOOL CAmorsDlg::DestroyWindow() 
{
	return CDialog::DestroyWindow();
}

void CAmorsDlg::ConfigureModule()
{
	CString strCStr="";
	std::string str="";
	m_eConfigName.GetWindowText(strCStr);
	str=strCStr.GetBuffer(strCStr.GetLength());
	str=AskForFile(str);
	if(str=="")
	{
		str=MakeAbsolute(strCStr.GetBuffer(strCStr.GetLength()),GetRootDir(),false);
	}
	m_ProcessConfig.SetPath(str);
	m_ProcessConfig.ReadFile();
	// Lunch Setup dialog
	CNewConfigDlg aDlg(str);
	aDlg.DoModal();
}

void CAmorsDlg::ReportProgress()
{
	m_ctrlPorgress.SetPos((int)m_fRepProgress);
	CString strHelp="";
	switch(m_iRepStage)
	{
		case -2:
					strHelp="Done.";
					break;
		case -1:
					strHelp="Waiting...";
					break;
		case SJ_PLGUIN_TYPE_ACQ:
					strHelp="Acquisition plugin";
					break;
		case SJ_PLGUIN_TYPE_OBJ_SEP:
					strHelp="ObjSep plugin";
					break;
		case SJ_PLGUIN_TYPE_DATABASE:
					strHelp="Database plugin";
					break;
		case SJ_PLGUIN_TYPE_FEATURE:
					strHelp="Feature plugin";
					break;
		default:
			strHelp="Unknown process";
	}
	while(!m_Specimen.IsLogEmpty())
	{
		CString str=m_Specimen.GetLogMessage().data();
		m_ctrlLBLog.AddString(str);
	}
	m_ctrlProgressLable.SetWindowText(strHelp);
}

UINT MainThread( LPVOID pParam )
{
    CAmorsDlg* oDlg= (CAmorsDlg*)pParam;
	oDlg->m_yInPerf=TRUE;
	if (oDlg == NULL)
			return 0;   // if oDlg is not valid
	int iRes=0;
	oDlg->m_Specimen.SetDisplayAddress(oDlg->m_ProcAddresses.Display);
    // lunch program loop here
	if(oDlg->m_iMode==ML_RESEAECH_MODE)
	{
		// want to make a reasearch
		iRes=ResearchLoop(oDlg->m_Specimen,oDlg->m_ProcAddresses);
	}
	if(oDlg->m_iMode==ML_NORMAL_MODE)
	{
		// just standard loop
		iRes=MainLoop(oDlg->m_Specimen,oDlg->m_ProcAddresses,oDlg->m_Specimen.GetIniFile()->GetValueI("Attached","Scans"));
	}
	// Check what the result is
	if(iRes==ML_FINISHED || iRes==ML_USER_INTERRUPTED)
	{
		// Successful exit from the loop
		//MessageBox("MainLoop is finished");
	}
	else
	{
		// Something happend inside???
		MessageBox(NULL,"Error in the MainLoop","Warning",0);
	}
	oDlg->m_yInPerf=FALSE;
	oDlg->UnloadLibraries();
    return 1;   // thread completed successfully
}

int CAmorsDlg::LoadLibraries()
{
	// PlugIn info
	tagPlugConf	PlugInConf;
	// Load Config
	CString strCStr="";
	std::string IniFName="";
	m_eConfigName.GetWindowText(strCStr);
	IniFName=strCStr.GetBuffer(strCStr.GetLength());
	IniFName=AskForFile(IniFName);
	m_ProcessConfig.Reset();
	m_ProcessConfig.SetPath(IniFName);
	m_ProcessConfig.ReadFile();
	// Fill information
	PlugInConf.strAcq=m_ProcessConfig.GetValue("Attached","Acq");
	PlugInConf.strDisplay=m_ProcessConfig.GetValue("Attached","Display");
	PlugInConf.strDataBase=m_ProcessConfig.GetValue("Attached","DataBase");
	PlugInConf.strObjSep=m_ProcessConfig.GetValue("Attached","ObjSep");
	// Now Feature plugIns
	PlugInConf.iTotalFeatures=m_ProcessConfig.GetValueI("Attached","TotalFeatures");
	std::string strHelp;
	for(int i=0;i<PlugInConf.iTotalFeatures;i++)
	{
		strHelp=Format("Feature%d",i);
		PlugInConf.arstrFeatures[i]=m_ProcessConfig.GetValue("Attached",strHelp);
	}
	// Want to be sure if we don't have an function address it's 0
	ZeroMemory(&m_ProcAddresses,sizeof(tagSJProcAddresses));
	// Load all libraries and get address
	// Get all adrresses
	if(	PlugInConf.strAcq!="" && 
		!GetProcAddresses(	&m_hAcqLib,PlugInConf.strAcq.data(),
							4,
							&(m_ProcAddresses.AcqSetup),"SetupDll",
							&(m_ProcAddresses.AcqInit),"Init",
							&(m_ProcAddresses.AcqDone),"Done",
							&(m_ProcAddresses.Acquire),"Acquire"))
	{
		MessageBox("Problem with loading Acq PlugIn","Error!",MB_OK|MB_ICONERROR);
		return 0;
	}
	if(	PlugInConf.strDisplay!="" &&
		!GetProcAddresses(	&m_hDispLib,PlugInConf.strDisplay.data(),
							6,
							&(m_ProcAddresses.DispResearchInit),"ResearchInit",
							&(m_ProcAddresses.DispResearchDone),"DispResearchDone",
							&(m_ProcAddresses.Update),"Update",
							&(m_ProcAddresses.DispInit),"Init",
							&(m_ProcAddresses.DispDone),"Done",
							&(m_ProcAddresses.Display),"Display"))
	{
		MessageBox("Problem with loading Display PlugIn","Error!",MB_OK|MB_ICONERROR);
		return 0;
	}
	if(	PlugInConf.strObjSep!="" && 
		!GetProcAddresses(	&m_hObjSepLib,PlugInConf.strObjSep.data(),
							4,
							&(m_ProcAddresses.SepSetup),"SetupDll",
							&(m_ProcAddresses.SepInit),"Init",
							&(m_ProcAddresses.SepDone),"Done",
							&(m_ProcAddresses.Separate),"Separate"))
	{
		MessageBox("Problem with loading Object Separation PlugIn","Error!",MB_OK|MB_ICONERROR);
		return 0;
	}
	if(	PlugInConf.strDataBase!="" && 
		!GetProcAddresses(	&m_hDataBaseLib,PlugInConf.strDataBase.data(),
							4,
							&(m_ProcAddresses.AnSetup),"SetupDll",
							&(m_ProcAddresses.AnInit),"Init",
							&(m_ProcAddresses.AnDone),"Done",
							&(m_ProcAddresses.Analyze),"Analyze"))
	{
		MessageBox("Problem with loading Data Base PlugIn","Error!",MB_OK|MB_ICONERROR);
		return 0;
	}

	// Load feature dlls
	m_ProcAddresses.iTotalFeatures=PlugInConf.iTotalFeatures;
	for(int iCount=0;iCount<PlugInConf.iTotalFeatures;iCount++)
	{
		if(	PlugInConf.arstrFeatures[iCount]!="" && 
			!GetProcAddresses(	&m_harFeatureLibs[iCount],PlugInConf.arstrFeatures[iCount].data(),
								2,
								&(m_ProcAddresses.FeatureSetup[iCount]),"SetupDll",
								&(m_ProcAddresses.Feature[iCount]),"ExtractFeature"))
		{
			MessageBox("Problem with loading Feature PlugIn","Error!",MB_OK|MB_ICONERROR);
			return 0;
		}

	}
	// Create objects and structures for processing!
	// Load config
	m_Specimen.GetIniFile()->SetPath(IniFName);
	m_Specimen.GetIniFile()->ReadFile();
	// Set variables for report function
	m_Specimen.SetReportVars(&m_iRepStage,&m_fRepProgress);
	m_yAbort=false;
	m_Specimen.SetAbortVar(&m_yAbort);
	// Adjust properties of the objects
	//.....

	// Disable buttons
	m_ctrlBtnLunch.EnableWindow(FALSE);
	m_ctrlBtnConfigure.EnableWindow(FALSE);
	m_ctrlBtnResearch.EnableWindow(FALSE);
	m_ctrlBtnTest.EnableWindow(FALSE);
	m_ctrlBtnDispLast.EnableWindow(FALSE);
	m_ctrlBtnBrowse.EnableWindow(FALSE);
	m_ctrlBtnClose.SetWindowText("&Abort");
	// Success
	return 1;
}

void CAmorsDlg::UnloadLibraries()
{
	m_OldSpecimen=m_Specimen;
	m_Specimen.Reset();
	// Free handles for libraries
	// Once handlers are freed I can not use object which were created
	// in these dlls, so I need to have a copy created in the main program!
	if(m_hAcqLib!=NULL) FreeLibrary(m_hAcqLib);
	if(m_hDispLib!=NULL) FreeLibrary(m_hDispLib);
	if(m_hObjSepLib!=NULL) FreeLibrary(m_hObjSepLib);
	for(int iCount=0;iCount<m_ProcAddresses.iTotalFeatures;iCount++)
	{
		if(m_harFeatureLibs[iCount]!=NULL)FreeLibrary(m_harFeatureLibs[iCount]);
	}
	if(m_hDataBaseLib!=NULL) FreeLibrary(m_hDataBaseLib);
	m_ctrlBtnLunch.EnableWindow();
	m_ctrlBtnConfigure.EnableWindow();
	m_ctrlBtnResearch.EnableWindow();
	m_ctrlBtnTest.EnableWindow();
	m_ctrlBtnDispLast.EnableWindow();
	m_ctrlBtnBrowse.EnableWindow();
	m_ctrlBtnClose.SetWindowText("&Close");
	m_fRepProgress=0;
	m_iRepStage=-2;
	ReportProgress();
}

void CAmorsDlg::OnStartUpBtnLunchConfig() 
{
	cout("Lunch is performed!");
	m_Specimen.Reset();
	m_iMode=ML_NORMAL_MODE;
	m_ctrlLBLog.ResetContent();
	if(LoadLibraries()==0)return;
	m_yInPerf=TRUE;
	// Run the thread.
	AfxBeginThread(MainThread, this);	
//	int iRes=MainLoop(m_Specimen,m_ProcAddresses,m_Specimen.GetIniFile()->GetValueI("Attached","Scans"));
//	UnloadLibraries();
}

void CAmorsDlg::OnTimer(UINT nIDEvent) 
{
	// if there's something going on reprot its progress
	if(m_yInPerf) ReportProgress();
	CDialog::OnTimer(nIDEvent);
}

void CAmorsDlg::OnStartUpBtnResearchMode() 
{
	m_Specimen.Reset();
	m_iMode=ML_RESEAECH_MODE;
	m_ctrlLBLog.ResetContent();
	if(LoadLibraries()==0)return;
	m_yInPerf=TRUE;
	// Run the thread.
	AfxBeginThread(MainThread, this);	
}

void CAmorsDlg::OnStartUpBtnDisplayLast() 
{
	if(!LoadLibraries())return;
	m_iMode=ML_NORMAL_MODE;
	m_yInPerf=TRUE;
	if(m_ProcAddresses.DispInit)m_ProcAddresses.DispInit(m_OldSpecimen);
	if(m_ProcAddresses.Display)m_ProcAddresses.Display(m_OldSpecimen);
	if(m_ProcAddresses.DispDone)m_ProcAddresses.DispDone(m_OldSpecimen);
	m_Specimen=m_OldSpecimen;
	UnloadLibraries();
	m_yInPerf=FALSE;
}

void CAmorsDlg::OnStartUpBtnBrowse() 
{
	if(m_yInPerf)return;
	// Choose the file to be loadded
	CFileDialog openDlg(true, "*.ini", "", OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
						"Configuration files(*.ini)|*.ini|All Files (*.*)|*.*||");
	// if file was chosen load it.
	if (openDlg.DoModal() == IDOK) m_eConfigName.SetWindowText(openDlg.GetPathName());
}

void CAmorsDlg::OnStartUpBtnConfigure() 
{
	m_ctrlLBLog.ResetContent();
	ConfigureModule();
}
