// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
// AmorsDlg.h : header file
//

#if !defined(AFX_AMORSDLG_H__89138174_6964_4341_B919_9F2367DBBD0D__INCLUDED_)
#define AFX_AMORSDLG_H__89138174_6964_4341_B919_9F2367DBBD0D__INCLUDED_

#include <string>
//#include "DibBuffer.h"

const std::string Preferences_ini_file="Amors.ini";


class CAmorsDlg : public CDialog
{
public:
	//CDibBuffer			m_DibBuf;
	BOOL				m_yInPerf;
	tagSJProcAddresses	m_ProcAddresses;
	CSJSpecimen			m_Specimen;
	// Stores results so libraries could be unloaded and we still could see the result.
	CSJSpecimen			m_OldSpecimen;
	int					m_iMode;
	void	UnloadLibraries();
protected:
	CSJIniFile		m_Preferences;
	CSJIniFile		m_ProcessConfig;
	int				m_iRepStage;
	float			m_fRepProgress;
	UINT			m_uTimerID;
	bool			m_yAbort;
	void ApplyPref();
	void SavePref();
	void ReportProgress();
	HINSTANCE	m_hAcqLib,
				m_hDispLib,
				m_hDataBaseLib,
				m_hObjSepLib,
				m_harFeatureLibs[MAX_PLUGINS];
	int LoadLibraries();
	//CWinThread       IFthread;
// Construction
public:
	CAmorsDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CAmorsDlg)
	enum { IDD = IDD_AMORS_DIALOG };
	CListBox	m_ctrlLBLog;
	CButton	m_ctrlBtnConfigure;
	CButton	m_ctrlBtnBrowse;
	CButton	m_ctrlBtnDispLast;
	CButton	m_ctrlBtnClose;
	CButton	m_ctrlBtnTest;
	CButton	m_ctrlBtnResearch;
	CButton	m_ctrlBtnLunch;
	CStatic	m_ctrlProgressLable;
	CProgressCtrl	m_ctrlPorgress;
	CEdit	m_eConfigName;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAmorsDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void ConfigureModule();
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CAmorsDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnStartUpBtnClose();
	afx_msg void OnStartUpBtnTest();
	afx_msg void OnClose();
	afx_msg void OnStartUpBtnLunchConfig();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnStartUpBtnResearchMode();
	afx_msg void OnStartUpBtnDisplayLast();
	afx_msg void OnStartUpBtnBrowse();
	afx_msg void OnStartUpBtnConfigure();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AMORSDLG_H__89138174_6964_4341_B919_9F2367DBBD0D__INCLUDED_)
