// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
// NewConfigDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Amors.h"
#include "NewConfigDlg.h"
#include <io.h>
#pragma warning(disable:4786)
#include <map>

/////////////////////////////////////////////////////////////////////////////
// CNewConfigDlg dialog


CNewConfigDlg::CNewConfigDlg(std::string strConfigName,CWnd* pParent /*=NULL*/)
	: CDialog(CNewConfigDlg::IDD, pParent)
{
	m_strConfigName=strConfigName;
	m_iTotalDlls=0;
	m_iScanNums=1;
	m_iAttachedNow=0;
}


void CNewConfigDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNewConfigDlg)
	DDX_Control(pDX, IDC_NEW_CONFIG_COMBO_OBJ_SEP, m_ctrlComboObjSep);
	DDX_Control(pDX, IDC_NEW_CONFIG_COMBO_DISPLAY, m_ctrlComboDisplay);
	DDX_Control(pDX, IDC_NEW_CONFIG_COMBO_DB, m_ctrlComboDB);
	DDX_Control(pDX, IDC_NEW_CONFIG_COMBO_ACQ, m_ctrlComboAcq);
	DDX_Control(pDX, IDC_IDC_NEW_CONFIG_EDIT_SCANS, m_ctrlEditScans);
	DDX_Control(pDX, IDC_IDC_NEW_CONFIG_LB_ATTACHED_PLUGINS, m_PlugInAttachedList);
	DDX_Control(pDX, IDC_NEW_CONFIG_LB_AVAILIBLE_PLUG_INS, m_PlugInFullList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNewConfigDlg, CDialog)
	//{{AFX_MSG_MAP(CNewConfigDlg)
	ON_BN_CLICKED(IDC_NEW_CONFIG_BTN_ATTACH, OnNewConfigBtnAttach)
	ON_BN_CLICKED(IDC_NEW_CONFIG_BTN_DETACH, OnNewConfigBtnDetach)
	ON_LBN_DBLCLK(IDC_IDC_NEW_CONFIG_LB_ATTACHED_PLUGINS, OnDblclkIdcNewConfigLbAttachedPlugins)
	ON_LBN_DBLCLK(IDC_NEW_CONFIG_LB_AVAILIBLE_PLUG_INS, OnDblclkNewConfigLbAvailiblePlugIns)
	ON_CBN_SELCHANGE(IDC_NEW_CONFIG_COMBO_ACQ, OnSelchangeNewConfigComboAcq)
	ON_CBN_SELCHANGE(IDC_NEW_CONFIG_COMBO_DB, OnSelchangeNewConfigComboDb)
	ON_CBN_SELCHANGE(IDC_NEW_CONFIG_COMBO_DISPLAY, OnSelchangeNewConfigComboDisplay)
	ON_CBN_SELCHANGE(IDC_NEW_CONFIG_COMBO_OBJ_SEP, OnSelchangeNewConfigComboObjSep)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNewConfigDlg message handlers

int CNewConfigDlg::FindAllPlugIns(std::string strAllAttachedPlugins)
{
	// Get each *.dll file from directory "PlugIns"
	// add it if it's possible
	
	// long _findfirst( char *filespec, struct _finddata_t *fileinfo );
	// struct _finddata_t
	//{
	// unsigned attrib;
	// time_t time_create;
	// time_t time_access;
	// time_t time_write;
	//_fsize_t size;
	// char name[FILENAME_MAX];
	//};
	int counter = 0;				// Counts number of found plugins
	_finddata_t file_info;		// Keeps file information
	std::string strSearchTemp=GetRootDir()+PATH_TO_PLUGINS + "*.dll";
	long lFirstFileRes = _findfirst(strSearchTemp.data(), &file_info);
	// if we don't get any dlls just exit.
	if (lFirstFileRes==-1)
	{
		MessageBox("No PlugIns detected.");
		return 0;
	}
	// CString dllPath=PATH_TO_PLUGINS+file_info.name;
	counter += AddPlugIn(PATH_TO_PLUGINS + file_info.name,strAllAttachedPlugins);
	while (_findnext(lFirstFileRes, &file_info)!=-1)
	{
		counter += AddPlugIn(PATH_TO_PLUGINS + file_info.name,strAllAttachedPlugins);
	}
	// Just free resources used by the search
	_findclose(lFirstFileRes);
	return counter;
}

// Returns 1 if plugin is valid, 0 otherwise
int CNewConfigDlg::AddPlugIn(std::string strName,std::string strAllAttachedPlugins)
{
	fntGetInfo GetInfo;
	fntGetType GetType;
	HINSTANCE hLib=NULL;
	// Good if nothing happened
	int iRes=1;
	std::string strFullPath=GetRootDir()+strName;
	// Load DLL and check if its valid!
	if (GetProcAddresses(&hLib, strFullPath.data(), 2, &GetInfo, "GetInfo",&GetType,"GetType"))
	{
		// Inforamtion will be returned here
		std::string inf;
		// call function (maybe need to use try and catch here!!!)
		int RetVal=GetInfo(inf);
		m_vecDllInfo[m_iTotalDlls].iIndex=m_iTotalDlls;
		m_vecDllInfo[m_iTotalDlls].strDesc=inf;
		m_vecDllInfo[m_iTotalDlls].strFN=strName;
		m_vecDllInfo[m_iTotalDlls].iAttached=FALSE;
		m_vecDllInfo[m_iTotalDlls].iRetType=RetVal;
		m_vecDllInfo[m_iTotalDlls].iType=GetType();
		if(strAllAttachedPlugins.find(strName,0)==std::string::npos)
			m_vecDllInfo[m_iTotalDlls].iAttached=FALSE;
		else 
		{
			m_vecDllInfo[m_iTotalDlls].iAttached=TRUE;
			m_iAttachedNow++;
		}
		// Increase total numbers of DLL's
		m_iTotalDlls++;
	}
	else
		iRes=0;
	if (hLib != NULL)
		FreeLibrary(hLib);	
	return iRes;
}

BOOL CNewConfigDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	IniConfig.SetPath(m_strConfigName);
	IniConfig.ReadFile();

	// Create a string with all names of attached plugins
	std::string strAllAttachedPlugins=
		IniConfig.GetValue("Attached","Acq")+"/n"+
		IniConfig.GetValue("Attached","Display")+"/n"+
		IniConfig.GetValue("Attached","DataBase")+"/n"+
		IniConfig.GetValue("Attached","ObjSep");
	std::string strHelp;
	for(int i=0;i<IniConfig.GetValueI("Attached","TotalFeatures");i++)
	{
		strHelp=Format("Feature%d",i);
		strAllAttachedPlugins+="/n"+IniConfig.GetValue("Attached",strHelp);
	}
	std::string strTemp=IniConfig.GetValue("Attached","Scans");
	if(strTemp!="")		m_iScanNums=IniConfig.GetValueI("Attached","Scans");
	// use 1 as default
				else	m_iScanNums=1;
	strHelp=Format("%d",m_iScanNums);
	CString strCStr=strHelp.data();
	m_ctrlEditScans.SetWindowText(strCStr);
	FindAllPlugIns(strAllAttachedPlugins);
	UpdatePlugInListBoxes();
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

int CNewConfigDlg::FindDllInfoIndex(int iLBIndex, bool yAttached)
{
	if (iLBIndex<0)return -1;
	for(int i=0;i<m_iTotalDlls;i++)
	{
		if(yAttached && m_vecDllInfo[i].iAttached>=0 && m_vecDllInfo[i].iIndex==iLBIndex)return i;
		if(!yAttached && m_vecDllInfo[i].iAttached<0 && m_vecDllInfo[i].iIndex==iLBIndex)return i;
	}
	return -1;
}

void CNewConfigDlg::OnNewConfigBtnAttach() 
{
	// Extract index in the DllInfo vector(the first number before colon)
	CString cstr;
	int iLBIndex=m_PlugInFullList.GetCurSel();
	if(iLBIndex<0)return;
	m_PlugInFullList.GetText(iLBIndex,cstr);
	int iT=cstr.Find(" : ",0);
	if(iT==-1){ MessageBox("Problem with plug-in assignment"); ASSERT(0);}
	int iDllInd=atoi(cstr.Left(iT));
	// Shouldn't be attached
	ASSERT(!m_vecDllInfo[iDllInd].iAttached);
	m_vecDllInfo[iDllInd].iAttached=TRUE;
    m_PlugInAttachedList.AddString(Format("%d - ",m_PlugInAttachedList.GetCount()+1).data()+cstr);
	m_PlugInFullList.DeleteString(iLBIndex);
	m_iAttachedNow++;
}

void CNewConfigDlg::OnNewConfigBtnDetach() 
{
	// Extract index in the DllInfo vector(the first number before colon)
	CString cstr;
	int iLBIndex=m_PlugInAttachedList.GetCurSel();
	if(iLBIndex<0)return;
	m_PlugInAttachedList.GetText(iLBIndex,cstr);
	int iT=cstr.Find(" - ",0);
	if(iT==-1){MessageBox("Problem with plug-in assignment"); ASSERT(0);}
	int iT2=cstr.Find(" : ",iT);
	if(iT==-1){MessageBox("Problem with plug-in assignment"); ASSERT(0);}
	int iDllInd=atoi(cstr.Mid(iT+3,iT2-iT-3));
	ASSERT(m_vecDllInfo[iDllInd].iAttached);
	m_vecDllInfo[iDllInd].iAttached=FALSE;
	m_PlugInFullList.AddString(Format("%d : %s",iDllInd,m_vecDllInfo[iDllInd].strDesc.data()).data());
	m_PlugInAttachedList.DeleteString(iLBIndex);
	// Reassign number for the rest of plug-ins
	for(int i=0;i<m_PlugInAttachedList.GetCount();i++)
	{
		CString cstr;
		m_PlugInAttachedList.GetText(i,cstr);
		int iT=cstr.Find(" - ",0);
		if(iT==-1){MessageBox("Problem with plug-in assignment"); ASSERT(0);}
		cstr=cstr.Right(cstr.GetLength()-iT-3);
		m_PlugInAttachedList.DeleteString(i);
		m_PlugInAttachedList.InsertString(i,Format("%d - ",i+1).data()+cstr);
	}
}

int CNewConfigDlg::GetPlugInIndexFromFileName(std::string str)
{
	// Find index for this plug-in;
	for(int j=0;j<m_iTotalDlls;j++)
		if(m_vecDllInfo[j].strFN==str)return j;
	return -1;
}

void CNewConfigDlg::UpdatePlugInListBoxes()
{
	m_PlugInAttachedList.ResetContent();
	m_PlugInFullList.ResetContent();
	m_ctrlComboAcq.ResetContent();
	m_ctrlComboDB.ResetContent();
	m_ctrlComboDisplay.ResetContent();
	m_ctrlComboObjSep.ResetContent();
	for(int i=0;i<m_iTotalDlls;i++)
		switch (m_vecDllInfo[i].iType)
		{
			case SJ_PLGUIN_TYPE_ACQ:
				m_ctrlComboAcq.AddString(Format("%d : %s",i,m_vecDllInfo[i].strDesc.data()).data());
				break;
			case SJ_PLGUIN_TYPE_OBJ_SEP:
				m_ctrlComboObjSep.AddString(Format("%d : %s",i,m_vecDllInfo[i].strDesc.data()).data());
				break;
			case SJ_PLGUIN_TYPE_DISPLAY:
				m_ctrlComboDisplay.AddString(Format("%d : %s",i,m_vecDllInfo[i].strDesc.data()).data());
				break;
			case SJ_PLGUIN_TYPE_DATABASE:
				m_ctrlComboDB.AddString(Format("%d : %s",i,m_vecDllInfo[i].strDesc.data()).data());
				break;
			case SJ_PLGUIN_TYPE_FEATURE:
				if(m_vecDllInfo[i].iAttached==FALSE)
					m_PlugInFullList.AddString(Format("%d : %s",i,m_vecDllInfo[i].strDesc.data()).data());
				break;
			default: MessageBox("Uknown type of plugin");
		}
	// Fill plug-ins which are attached
	for(i=0;i<IniConfig.GetValueI("Attached","TotalFeatures");i++)
	{
		std::string strHelp=IniConfig.GetValue("Attached",Format("Feature%d",i));
		int iIndex=GetPlugInIndexFromFileName(strHelp);
		m_PlugInAttachedList.AddString(Format("%d - %d : %s",m_PlugInAttachedList.GetCount()+1,iIndex,m_vecDllInfo[iIndex].strDesc.data()).data());
	}

#define FILL_COMBO(x,y) iIndex=GetPlugInIndexFromFileName(IniConfig.GetValue("Attached",x));\
						if(iIndex==-1)iIndex=CB_ERR;\
						else iIndex=y.FindStringExact(-1,Format("%d : %s",iIndex,m_vecDllInfo[iIndex].strDesc.data()).data());\
						if(iIndex!=CB_ERR) y.SetCurSel(iIndex);

	int iIndex=-1;
	FILL_COMBO("Acq",m_ctrlComboAcq);
//	iIndex=GetPlugInIndexFromFileName(IniConfig.GetValue("Attached","Acq"));
//						if(iIndex==-1)iIndex=CB_ERR;
//						else iIndex=m_ctrlComboAcq.FindStringExact(-1,Format("%d : %s",iIndex,m_vecDllInfo[iIndex].strDesc.data()).data());
//						if(iIndex!=CB_ERR) m_ctrlComboAcq.SetCurSel(iIndex);
	FILL_COMBO("Display",m_ctrlComboDisplay);
	FILL_COMBO("DataBase",m_ctrlComboDB);
	FILL_COMBO("ObjSep",m_ctrlComboObjSep);
	// In case if I want to remove plug-in
	m_ctrlComboDB.AddString("");
	m_ctrlComboAcq.AddString("");
	m_ctrlComboDisplay.AddString("");
	m_ctrlComboObjSep.AddString("");
}

void CNewConfigDlg::OnOK() 
{
	// Check for validity of chosen plugins (like 2 acq modules are too much :) )
	CString strHelp;
	m_ctrlEditScans.GetWindowText(strHelp);
	m_iScanNums=atoi(strHelp);
	// Save ini file here!
	SetupEachPlugin();
	CDialog::OnOK();
}

int CNewConfigDlg::GetPlugInIndexFromCombo(CComboBox &cb)
{
	CString cstr;
	cb.GetWindowText(cstr);
	int iT=cstr.Find(" : ",0);
	if(iT==-1)return -1;
	int iDllInd=atoi(cstr.Left(iT));
	return iDllInd;
}
#define USE_COMBO(x) iIndex=GetPlugInIndexFromCombo(x);if(iIndex>=0)m_vecDllInfo[iIndex].iAttached=TRUE
void CNewConfigDlg::SetupEachPlugin()
{
	tagPlugConf PlguInConfig;
	PlguInConfig.iTotalFeatures=0;
	int iIndex=-1;
	USE_COMBO(m_ctrlComboAcq);
	USE_COMBO(m_ctrlComboDB);
	USE_COMBO(m_ctrlComboDisplay);
	USE_COMBO(m_ctrlComboObjSep);
	for(int i=0;i<m_iTotalDlls;i++)
	{
		if(m_vecDllInfo[i].iAttached==TRUE)
		{
			switch (m_vecDllInfo[i].iType)
			{
				case SJ_PLGUIN_TYPE_ACQ:
					if(PlguInConfig.strAcq=="")	PlguInConfig.strAcq=m_vecDllInfo[i].strFN;
						else MessageBox("Too many acq modules, only one is used");
										break;
				case SJ_PLGUIN_TYPE_OBJ_SEP:
					if(PlguInConfig.strObjSep=="")	PlguInConfig.strObjSep=m_vecDllInfo[i].strFN;
						else MessageBox("Too many ObjSep modules, only one is used");
										break;
				case SJ_PLGUIN_TYPE_DISPLAY:
					if(PlguInConfig.strDisplay=="")	PlguInConfig.strDisplay=m_vecDllInfo[i].strFN;
						else MessageBox("Too many Display modules, only one is used");
										break;
				case SJ_PLGUIN_TYPE_DATABASE:
					if(PlguInConfig.strDataBase=="") PlguInConfig.strDataBase=m_vecDllInfo[i].strFN;
						else MessageBox("Too many DataBase modules, only one is used");
										break;
				case SJ_PLGUIN_TYPE_FEATURE:
						PlguInConfig.arstrFeatures[PlguInConfig.iTotalFeatures]=m_vecDllInfo[i].strFN;
						PlguInConfig.iTotalFeatures++;
					break;
				default: MessageBox("Uknown type of plugin");

			}
			switch (m_vecDllInfo[i].iRetType)
			{
				case SJ_MFC_DIALOG_SETUP:  CallSetup(m_vecDllInfo[i].strFN);
										break;
				default:;
			}
		}
	}
	IniConfig.ReadFile();
	// Now I want clear section for attached, so no old information is there
	IniConfig.DeleteKey("Attached");
	// now fill it!
	IniConfig.SetValue("Attached","Acq",PlguInConfig.strAcq);
	IniConfig.SetValue("Attached","Display",PlguInConfig.strDisplay);
	IniConfig.SetValue("Attached","DataBase",PlguInConfig.strDataBase);
	IniConfig.SetValue("Attached","ObjSep",PlguInConfig.strObjSep);
	IniConfig.SetValueI("Attached","TotalFeatures",PlguInConfig.iTotalFeatures);
	// Save feature plug-ins in the ini
	for(i=0;i<m_PlugInAttachedList.GetCount();i++)
	{
		// Extract index in the DllInfo vector(the first number before colon)
		CString cstr;
		m_PlugInAttachedList.GetText(i,cstr);
		int iT=cstr.Find(" - ",0);
		if(iT==-1){MessageBox("Problem with plug-in assignment"); ASSERT(0);}
		int iT2=cstr.Find(" : ",iT);
		if(iT==-1){MessageBox("Problem with plug-in assignment"); ASSERT(0);}
		int iDllInd=atoi(cstr.Mid(iT+3,iT2-iT-3));
		ASSERT(m_vecDllInfo[iDllInd].iAttached);
		IniConfig.SetValue("Attached",Format("Feature%d",i),m_vecDllInfo[iDllInd].strFN);
	}
	IniConfig.SetValueI("Attached","Scans",m_iScanNums);
	IniConfig.WriteFile();
}

void CNewConfigDlg::CallSetup(std::string strName)
{
	//Call Setup From DLL here!
	fntSetupForDll SetupDll;
	HINSTANCE hLib;
	// Load DLL and check if its valid!
	if (GetProcAddresses(&hLib, strName.data(), 1, &SetupDll, "SetupDll"))
	{
		// Save what we have for ini
		IniConfig.WriteFile();
		// call function (maybe need to use try and catch here!!!)
		// if load was successful, reread ini file!
		//if(SetupDll(pcConfigName))IniConfig.ReadFile();
		SetupDll(m_strConfigName.data());
		// Load changes
		IniConfig.ReadFile();
		// Show it to the user
	}
	else
		return;
	if (hLib != NULL)
		FreeLibrary(hLib);	
}

void CNewConfigDlg::OnDblclkIdcNewConfigLbAttachedPlugins() 
{
	OnNewConfigBtnDetach();
}

void CNewConfigDlg::OnDblclkNewConfigLbAvailiblePlugIns() 
{
	OnNewConfigBtnAttach();
}

void CNewConfigDlg::UpdateCombo(CComboBox &cb)
{
	// Detach all plug-ins in this combo
	for(int i=0;i<cb.GetCount();i++)
	{
		CString cstr;
		cb.GetLBText(i,cstr);
		int iT=cstr.Find(" : ",0);
		if(iT==-1)return;
		int iDllInd=atoi(cstr.Left(iT));
		m_vecDllInfo[iDllInd].iAttached=FALSE;
	}
	// Now attached the chosen one:
	int iIndex=GetPlugInIndexFromCombo(cb);
	if(iIndex>=0)m_vecDllInfo[iIndex].iAttached=TRUE;
}

void CNewConfigDlg::OnSelchangeNewConfigComboAcq() 
{
	UpdateCombo(m_ctrlComboAcq);
}

void CNewConfigDlg::OnSelchangeNewConfigComboDb() 
{
	UpdateCombo(m_ctrlComboDB);
}

void CNewConfigDlg::OnSelchangeNewConfigComboDisplay() 
{
	UpdateCombo(m_ctrlComboDisplay);
}

void CNewConfigDlg::OnSelchangeNewConfigComboObjSep() 
{
	UpdateCombo(m_ctrlComboObjSep);
}
