// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
#if !defined(AFX_NEWCONFIGDLG_H__CCE780A8_5D7D_4659_940A_E40B1026DF29__INCLUDED_)
#define AFX_NEWCONFIGDLG_H__CCE780A8_5D7D_4659_940A_E40B1026DF29__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// NewConfigDlg.h : header file
//
/////////////////////////////////////////////////////////////////////////////
// CNewConfigDlg dialog
#include <string>

class CNewConfigDlg : public CDialog
{
struct taqDllInfo
{
	// Location of the dll (path and name)
	std::string strFN;
	// Description of the dll
	std::string strDesc;
	// Index in the list box
	int iIndex;
	// Shows if we want to use this dll
	int iAttached;
	// Indicates if this function has setup window
	int iRetType;
	// type of plugIn
	int iType;
};

protected:
	int GetPlugInIndexFromCombo(CComboBox &cb);
	int GetPlugInIndexFromFileName(std::string str);
	void UpdateCombo(CComboBox &cb);
	int	FindAllPlugIns(std::string strAllAttachedPlugins);
	int AddPlugIn(std::string strName,std::string strAllAttachedPlugins);
	// Contains names of dlls
	taqDllInfo		m_vecDllInfo[MAX_PLUGINS];
	// Number of all dlls availible
	int				m_iTotalDlls;
	int				m_iScanNums;
	int				m_iAttachedNow;

// Construction
public:
	void UpdatePlugInListBoxes();
	CNewConfigDlg(std::string strConfigName,CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CNewConfigDlg)
	enum { IDD = IDD_NEW_CONFIG };
	CComboBox	m_ctrlComboObjSep;
	CComboBox	m_ctrlComboDisplay;
	CComboBox	m_ctrlComboDB;
	CComboBox	m_ctrlComboAcq;
	CEdit	m_ctrlEditScans;
	CListBox	m_PlugInAttachedList;
	CListBox	m_PlugInFullList;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CNewConfigDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	std::string m_strConfigName;
	CSJIniFile IniConfig;
	void CallSetup(std::string strName);
	void SetupEachPlugin();
	int FindDllInfoIndex(int iLBIndex,bool yAttached);

	// Generated message map functions
	//{{AFX_MSG(CNewConfigDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnNewConfigBtnAttach();
	afx_msg void OnNewConfigBtnDetach();
	virtual void OnOK();
	afx_msg void OnDblclkIdcNewConfigLbAttachedPlugins();
	afx_msg void OnDblclkNewConfigLbAvailiblePlugIns();
	afx_msg void OnSelchangeNewConfigComboAcq();
	afx_msg void OnSelchangeNewConfigComboDb();
	afx_msg void OnSelchangeNewConfigComboDisplay();
	afx_msg void OnSelchangeNewConfigComboObjSep();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_NEWCONFIGDLG_H__CCE780A8_5D7D_4659_940A_E40B1026DF29__INCLUDED_)
