// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
// TestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Amors.h"
#include "TestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestDlg dialog


CTestDlg::CTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestDlg)
	DDX_Control(pDX, IDC_TEST_DLG_LOG_LIST, m_lbLogList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTestDlg, CDialog)
	//{{AFX_MSG_MAP(CTestDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDlg message handlers

BOOL CTestDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	//TestSJBuffer();		
	//TestSJImage();
	//TestSJImageList();
	TestSJObjectInfo();
	//TestSJSpecimen();
	//TesPWD();
	//TestDll();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTestDlg::TesPWD()
{
	m_lbLogList.AddString(GetWorkingDir().data());
	m_lbLogList.AddString(GetRootDir().data());
}

void CTestDlg::TestSJSpecimen()
{
	CSJSpecimen Specimen;
	{
	CSJImage	Image1,
				Image2;
	Image1.CreateFromFile("../samples/rice.tif");
	Image2.CreateFromFile("../samples/real.tif");
	Specimen.GetImageList()->Add(Image1);
	Specimen.GetImageList()->Add(Image2);
	}
	Specimen.GetImageList()->Clear();
	cout("done");
}

void CTestDlg::TestSJObjectInfoList()
{
#undef LogOut
#define LogOut(Num) str.Format("%d",Num);m_lbLogList.AddString(str);str=""
	CString str;
	CSJObjectInfo ObjectInfo;
	ObjectInfo.SetValue("Value1",100);
	ObjectInfo.SetValue("Value3",-300);

	CSJObjectInfoList ObjList;
	LogOut(ObjList.GetLength());
	
	ObjList.Add(ObjectInfo);
	LogOut(ObjList.GetLength());
}

void CTestDlg::TestSJObjectInfo()
{
#undef LogOut
#define LogOut(Num) str.Format("%d",Num);m_lbLogList.AddString(str);str=""
	CString str;
	CSJObjectInfo ObjectInfo;
	
	LogOut(ObjectInfo.GetNumVars());
	ObjectInfo.SetValue("Value1",100);
	LogOut(ObjectInfo.GetNumVars());
	ObjectInfo.SetValue("Value2",200);
	LogOut(ObjectInfo.GetNumVars());
	ObjectInfo.SetValue("Value3",300);
	LogOut(ObjectInfo.GetNumVars());
	ObjectInfo.SetValue("Value4",400);
	LogOut(ObjectInfo.GetNumVars());
	LogOut(ObjectInfo.GetValueI("Value1"));
	LogOut(ObjectInfo.GetValueI("Value2"));
	LogOut(ObjectInfo.GetValueI("Value3"));
	LogOut(ObjectInfo.GetValueI("Value4"));
	ObjectInfo.SetValue("Value1",-100);
	LogOut(ObjectInfo.GetValueI("Value1"));
	ObjectInfo.SetValue("Value3",-300);
	LogOut(ObjectInfo.GetValueI("Value3"));
	LogOut(ObjectInfo.GetValueI("Value2"));
	CSJObjectInfo ObjectInfo2=ObjectInfo;
	LogOut(ObjectInfo2.GetNumVars());
}

void CTestDlg::TestSJImageList()
{
#undef LogOut
#define LogOut(Num) str.Format("I%d - %d,%d,n- %d, p- %f",Num,Image##Num.GetWidth(),Image##Num.GetHeight(),Image##Num.GetNumber(),Image##Num.GetParameter());m_lbLogList.AddString(str);str=""
	CString str;
	CSJImageList ImageList;
	ImageList.Clear();
	{
		CSJImage	Image1,
					Image2;
		LogOut(1);LogOut(2);
		Image1.Create(100,100,COLOR_DEPTH_8BITS,1,0.1f);
		Image2.Create(200,300,COLOR_DEPTH_8BITS,2,0.5f);
		LogOut(1);LogOut(2);
		ImageList.Add(Image1);
		ImageList.Add(Image2);
	}
	CSJImage	Image1,
				Image2;

//	Image1.Create(1,1,COLOR_DEPTH_8BITS,0,0);
//	Image2.Create(1,1,COLOR_DEPTH_8BITS,0,0);
	LogOut(1);LogOut(2);
	Image1=*ImageList.GetImage(1);
	Image2=*ImageList.GetImage(0);
	ImageList.Clear();
	LogOut(1);LogOut(2);
//	ImageList.Delete(1);
//	ImageList.Delete(0);
	// Should be an error and it is.
//	Image1=*ImageList.GetImage(1);
//	Image2=*ImageList.GetImage(0);

	Image1.CreateFromFile("../samples/rice.tif");
	Image2.CreateFromFile("../samples/real.tif");
	LogOut(1);LogOut(2);
	ImageList.Add(Image1);
	ImageList.Add(Image2);
	Image1=*ImageList.GetImage(1);
	Image2=*ImageList.GetImage(0);
	LogOut(1);LogOut(2);
}

void CTestDlg::TestSJImage()
{
#undef LogOut
#define LogOut(Num) str.Format("I%d - %u,%u",Num,Image##Num.GetWidth(),Image##Num.GetHeight());m_lbLogList.AddString(str);str=""
	CString str;
	CSJImage	Image1,
				Image2;
	LogOut(1);LogOut(2);
	Image1=Image2;
	LogOut(1);LogOut(2);
	Image1.Create(100,100,COLOR_DEPTH_8BITS,1,0.1f);
	Image2.Create(200,300,COLOR_DEPTH_8BITS,2,0.5f);
	LogOut(1);LogOut(2);
	CSJImage	Image3=Image1;
	CSJImage	Image4(Image2);
	LogOut(3);
	LogOut(4);
	CSJImage	Image5;
	Image5.CreateFromFile("../samples/ms.tif");
	LogOut(5);
}

void CTestDlg::TestSJBuffer()
{

#undef LogOut
#define LogOut(Num) str.Format("B%d - %d,%d",Num,Buffer##Num.GetWidth(),Buffer##Num.GetHeight());m_lbLogList.AddString(str);str=""
	CString		str;
	CSJBuffer	Buffer1,
				Buffer2,
				Buffer3;
LogOut(1);LogOut(2);LogOut(3);
	Buffer1.Create(100,100);
	Buffer2.Create(300,200);
LogOut(1);LogOut(2);LogOut(3);
	Buffer3=Buffer1;
	Buffer1=Buffer2;
LogOut(1);LogOut(2);LogOut(3);
	CSJBuffer Buffer4(Buffer2);
	LogOut(4);
	Buffer4=Buffer3;
	LogOut(4);
	CSJBuffer Buffer5=Buffer4;
LogOut(5);
}
