// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
//$Header: c:\\users\\sj\\CVS/Thesis/Interfaces/Console.h,v 2.0 2002/01/28 16:26:02 sj Exp $
//http://www.codeproject.com/useritems/dhananjaygune_cout.asp
//By Dhananjay Gune 
/* Author: Dhandy */

#ifndef _CONSOLE_H_
#define _CONSOLE_H_

// uncomment the line below to get the console in release version also.
//#define _RELEASE_CONSOLE_

#ifdef _DEBUG
	#define WANT_DEBUG_CONSOLE
#else
	#ifdef _RELEASE_CONSOLE_
		#define WANT_DEBUG_CONSOLE
	#endif
#endif

#ifdef WANT_DEBUG_CONSOLE
	#define CreateConsole()		{	AllocConsole();		}
	#define DeleteConsole()		{	FreeConsole();		}
	#define cout(val) _cout(_T("")_T(#val), val)
#else
	#define CreateConsole()
	#define DeleteConsole()
	#define cout(val)
#endif

#ifdef WANT_DEBUG_CONSOLE

inline CString GetLastErrorText(BOOL bShowMessageBoxAlso = TRUE)
{
	LPVOID lpMsgBuf;
	FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
		NULL, GetLastError(), MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPTSTR) &lpMsgBuf, 0, NULL );

	CString cstrMessageText = (LPTSTR)lpMsgBuf;

	if(bShowMessageBoxAlso == TRUE)
	{
		// Display the string.
		MessageBox( NULL, cstrMessageText, _T("GetLastErrorText"), MB_OK|MB_ICONINFORMATION );
	}
	// Free the buffer.
	LocalFree( lpMsgBuf );
	return cstrMessageText;
}



inline void _cout(CString dummy, CString string)
{
	DWORD dwBytes;
	if(dummy.Find(_T('"')) == -1)
	{
		dummy += _T(" = ");
	}
	else
	{
		dummy = "";
	}
	CString cstrBuf = dummy;
	cstrBuf +=  string + _T('\n');
	WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), (LPCTSTR)cstrBuf, cstrBuf.GetLength() + 1, &dwBytes, NULL);
}


inline void _cout(char ch)
{
	DWORD dwBytes;
	CString cstrBuf = ch;
	cstrBuf += _T('\n');
	WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), (LPCTSTR)cstrBuf, cstrBuf.GetLength() + 1, &dwBytes, NULL);
}


inline void _cout(unsigned char ch)
{
	DWORD dwBytes;
	CString cstrBuf = ch;
	cstrBuf += _T('\n');
	WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), (LPCTSTR)cstrBuf, cstrBuf.GetLength() + 1, &dwBytes, NULL);
}


inline void _cout(CString cstr, int n)
{
	DWORD dwBytes;
	CString cstrBuf;
	cstrBuf.Format(_T(" = %d\n"), n);
	cstr += cstrBuf;
	cstrBuf = cstr;
	WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), (LPCTSTR)cstrBuf, cstrBuf.GetLength() + 1, &dwBytes, NULL);
}


inline void _cout(CString cstr, unsigned int n)
{
	DWORD dwBytes;
	CString cstrBuf;
	cstrBuf.Format(_T(" = %d\n"), n);
	cstr += cstrBuf;
	cstrBuf = cstr;
	WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), (LPCTSTR)cstrBuf, cstrBuf.GetLength() + 1, &dwBytes, NULL);
}


inline void _cout(CString cstr, float n)
{
	DWORD dwBytes;
	CString cstrBuf;
	cstrBuf.Format(_T(" = %f\n"), n);
	cstr += cstrBuf;
	cstrBuf = cstr;
	WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), (LPCTSTR)cstrBuf, cstrBuf.GetLength() + 1, &dwBytes, NULL);
}

inline void _cout(CString cstr, double n)
{
	DWORD dwBytes;
	CString cstrBuf;
	cstrBuf.Format(_T(" = %g\n"), n);
	cstr += cstrBuf;
	cstrBuf = cstr;
	WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), (LPCTSTR)cstrBuf, cstrBuf.GetLength() + 1, &dwBytes, NULL);
}


inline void _cout(CString cstr, long n)
{
	DWORD dwBytes;
	CString cstrBuf;
	cstrBuf.Format(_T(" = %u\n"), n);
	cstr += cstrBuf;
	cstrBuf = cstr;
	WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), (LPCTSTR)cstrBuf, cstrBuf.GetLength() + 1, &dwBytes, NULL);
}


inline void _cout(CString cstr, unsigned long n)
{
	DWORD dwBytes;
	CString cstrBuf;
	cstrBuf.Format(_T(" = %u\n"), n);
	cstr += cstrBuf;
	cstrBuf = cstr;
	WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), (LPCTSTR)cstrBuf, cstrBuf.GetLength() + 1, &dwBytes, NULL);
}

#endif // WANT_DEBUG_CONSOLE


#endif // _CONSOLE_H_
