// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
//$Header: c:\\users\\sj\\CVS/Thesis/Interfaces/MainLoop.h,v 2.3 2002/04/19 18:18:45 sj Exp $
#if !defined(MAIN_LOOP_H_INCLUDED)
#define MAIN_LOOP_H_INCLUDED


#include "SJSpecimen.h"
#include "console.h"


const int MAX_PLUGINS = 120;

// Function type GetInfo
typedef int(*fntGetInfo)(std::string&);
typedef int(*fntSetupForDll)(const char*);
typedef int(*fntGetType)();
typedef int(*fntAcquire)(CSJSpecimen&,int);
typedef int(*fntSeparate)(CSJSpecimen&);
typedef int(*fntAnalyze)(CSJSpecimen&);
typedef int(*fntDisplay)(CSJSpecimen&);
typedef int(*fntInit)(CSJSpecimen&);
typedef int(*fntDone)(CSJSpecimen&);
typedef int(*fntExtractFeature)(CSJSpecimen&);

// Should be filled by program in order to perform operation!
struct tagSJProcAddresses
{
	fntAcquire		Acquire;
	fntDisplay		Display,
					Update;
	fntSeparate		Separate;
	fntAnalyze		Analyze;
	fntInit			AcqInit,
					SepInit,
					AnInit,
					DispResearchInit,
					DispInit;
	fntDone			AcqDone,
					SepDone,
					AnDone,
					DispResearchDone,
					DispDone;
	fntSetupForDll  AcqSetup,
					SepSetup,
					AnSetup,
					FeatureSetup[MAX_PLUGINS];
	int				iTotalFeatures;
	fntExtractFeature	Feature[MAX_PLUGINS];

};

enum ML_CODES {	ML_FINISHED, 
				ML_USER_INTERRUPTED, 
				ML_BAD_PROC_ADDR, 
				ML_NO_DISPLAY,
                                ML_NORMAL_MODE,
                                ML_RESEAECH_MODE
				};

// Specimen - address of object to store all information at
// prAddr	- addresses of all procedures in the modules to be called
// wSacnNum - number of scans to be performed ((-1)-interrupts when display module returns FALSE)
int MainLoop(CSJSpecimen &Specimen, tagSJProcAddresses &prAddr, WORD wScanNum=1);
int ResearchLoop(CSJSpecimen &Specimen, tagSJProcAddresses &prAddr);

#endif // !defined(MAIN_LOOP_H_INCLUDED)
