// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
//$Header: c:\\users\\sj\\CVS/Thesis/Interfaces/SJBuffer.h,v 2.3 2002/03/02 20:26:41 sj Exp $
// Oleksandr Shyrokov shirokov@unh.edu 10/03/2001 UNH
// For Amors project
// SJBuffer.h: interface for the CSJBuffer class.

// Call Create function with dimesions of the buffer.
#if !defined(SJBUFFER_H_INCLUDED)
#define SJBUFFER_H_INCLUDED

enum BYTES_PER_PIXEL { ONE_BYTE=1, TWO_BYTES=2, THREE_BYTES=3};

class CSJBuffer
{
public:
	// Copy Constructor
	CSJBuffer(const CSJBuffer &bufobj);
	CSJBuffer();
	bool Create(int iWidth, int iHeight, int iBytesPerPixel=ONE_BYTE);
	virtual ~CSJBuffer();
	CSJBuffer &operator=(const CSJBuffer &bufobj);
	void Copy(CSJBuffer &bufobj, bool yKeepOriginalBPP=false, int iLeft=0, int iTop=0, int iRight=0, int iBottom=0);
	void CopyIntoPos(CSJBuffer &bufobj, int iLeft=0, int iTop=0);

	int		GetHeight(){return m_iHeight;};
	int		GetWidth(){return m_iWidth;};
	int		GetBufferSize(){return m_iWidth*m_iHeight*m_iBytesPerPixel;};
	void	ClearMemory(){ZeroMemory(GetBuffer(),GetBufferSize());};
	bool	FillBufferFrom(byte *pbSrcBuf,int iLength);
	bool	FillBufferFrom(CSJBuffer &bufobj);
	int		GetBytesPP(){return m_iBytesPerPixel;};
	byte*	GetByteBuffer(){return m_pbBuffer;};
	WORD*	GetWordBuffer(){return m_pwBuffer;};
	WORD	GetWordValue(int iX, int iY);
	byte	GetByteValue(int iX, int iY);
	WORD	GetValue(int iX, int iY);
	void	SetWordValue(int iX, int iY, WORD wValue);
	void	SetByteValue(int iX, int iY, byte bValue);
	void	SetValue(int iX, int iY, WORD wValue);
	void	SetDirectValue(int iP, WORD wValue);
	WORD	GetDirectValue(int iP);
// data manipulation
	void	Invert();
// math functions
	double	Mean2();
	double	Std2();
	WORD	Min();
	WORD	Max();
	void	Crop(int iLeft, int iTop, int iRight=0, int iBottom=0);
private:
	int		m_iBytesPerPixel;
	byte*	GetBuffer(){return m_pbBuffer;};
	void	FreeMemoryBuffer();
	int		m_iWidth;
	int		m_iHeight;
	// they will point to the same memory!
	byte*	m_pbBuffer; // for ONE_BYTE
	WORD*	m_pwBuffer; // for TWO_BYTES
};

#endif // !defined(SJBUFFER_H_INCLUDED)
