// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
//$Header: c:\\users\\sj\\CVS/Thesis/Interfaces/SJImageList.h,v 2.1 2002/02/08 01:06:52 sj Exp $
// Oleksandr Shyrokov shirokov@unh.edu 10/03/2001 UNH
// For Amors project
// SJImageList.h: interface for the CSJImageList class.

#if !defined(SJIMAGELIST_H_INCLUDED)
#define SJIMAGELIST_H_INCLUDED

#pragma warning(disable:4786)
#include <vector>
#include "SJImage.h"

class CSJImageList  
{
protected:
	// Array of images.
	std::vector<CSJImage> m_Images;
public:
	// Whant to have some memory reserved so no need for ofthen relocations
	CSJImageList(){m_Images.reserve(10);};
	virtual ~CSJImageList(){while(!m_Images.empty())m_Images.erase(m_Images.begin());};
	void Add(CSJImage newImage){m_Images.push_back(newImage);};
	void Delete(unsigned int iIndex=0);
	int GetLength(){return m_Images.size();};
	CSJImage* GetImage(unsigned int iIndex);
	void Clear(){m_Images.clear();};
};

#endif // !defined(SJIMAGELIST_H_INCLUDED)
