// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
//$Header: c:\\users\\sj\\CVS/Thesis/Interfaces/SJObjectInfo.h,v 2.4 2002/04/12 14:17:06 sj Exp $
// Oleksandr Shyrokov shirokov@unh.edu 10/03/2001 UNH
// For Amors project
// SJObjectInfo.h: interface for the CSJObjectInfo class.

#if !defined(SJOBJECTINFO_H_INCLUDED)
#define SJOBJECTINFO_H_INCLUDED

#include "SJImage.h"
#include "SJIniFile.h"

class CSJRect
{
public:
	CSJRect(int iL, int iR, int iT, int iB){m_iLeft=iL;m_iRight=iR;m_iTop=iT;m_iBottom=iB;};
	CSJRect(){Clear();};
	~CSJRect(){};
	int			m_iLeft;
	int			m_iRight;
	int			m_iTop;
	int			m_iBottom;
	int Height(){return m_iBottom-m_iTop+1;};
	int Width(){return m_iRight-m_iLeft+1;};
	void Clear(){m_iLeft=0;m_iTop=0;m_iRight=0;m_iBottom=0;};
	int Area(){return Height()*Width();};
	bool PtInRect(int iX,int iY){if(iX>=m_iLeft && iX<=m_iRight && iY>=m_iTop && iY<=m_iBottom)return true; else return false;};
	void ShiftBy(int iX, int iY){m_iLeft+=iX;m_iRight+=iX;m_iTop+=iY;m_iBottom+=iY;};
};

class CSJObjectInfo
{
private:
	CSJIniFile		m_Info;
	// Contains the binary shape of the detected object
	CSJBuffer		m_BinaryMap;
	CSJImage		m_Transfomed;
public:
	CSJRect			Rect;
	CSJObjectInfo();
	// Copy constructor
	// Default should be the same
	//CSJObjectInfo(const CSJObjectInfo& orig);
	virtual ~CSJObjectInfo(){};
	bool SetValue(std::string strName,int iValue);
	bool SetValue(std::string strName,double dValue);
	bool SetValue(std::string strName,std::string strValue);
	std::string GetValue(std::string strVarName);
	int GetValueI(std::string strVarName);
	double GetValueF(std::string strVarName);
	int GetNumVars();
	CSJBuffer* GetBinaryMap(){return &m_BinaryMap;};
	CSJImage* GetTransformed(){return &m_Transfomed;};
	bool HaveValue(std::string strVarName);
	void Clear(){m_Info.Reset();m_BinaryMap.Create(1,1);Rect.Clear();};
	std::string GetNameAt(int iIndex){return m_Info.GetVarName("0",iIndex);};
	std::string GetValueAt(int iIndex){return m_Info.GetValue("0",GetNameAt(iIndex));};
	void DeleteValue(std::string strVarName){m_Info.DeleteValue("0",strVarName);};
};

#endif // !defined(SJOBJECTINFO_H_INCLUDED)
