// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
//$Header: c:\\users\\sj\\CVS/Thesis/Interfaces/SJObjectInfoList.h,v 2.0 2002/01/28 16:26:02 sj Exp $
// Oleksandr Shyrokov shirokov@unh.edu 10/03/2001 UNH
// For Amors project
// SJObjectInfoList.h: interface for the CSJObjectInfoList class.

#if !defined(SJOBJECTINFOLIST_H_INCLUDED)
#define SJOBJECTINFOLIST_H_INCLUDED

#pragma warning(disable:4786)
#include <vector>

#include "SJObjectInfo.h"

class CSJObjectInfoList  
{
private:
	// Array of images.
	std::vector<CSJObjectInfo> m_ObjectList;
public:
	CSJObjectInfoList(){};
	virtual ~CSJObjectInfoList(){};
	void Add(CSJObjectInfo &newObj){m_ObjectList.push_back(newObj);};
	void Delete(int iIndex)
	{
		if(iIndex>=GetLength())return;
		m_ObjectList.erase(&m_ObjectList.at(iIndex));
	};
	int GetLength(){return m_ObjectList.size();};
	CSJObjectInfo* GetObjectInfo(int iIndex){if(iIndex<GetLength())return&m_ObjectList.at(iIndex);else return NULL;};
	void Clear(){m_ObjectList.clear();};
};

#endif // !defined(SJOBJECTINFOLIST_H_INCLUDED)
