// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
//$Header: c:\\users\\sj\\CVS/Thesis/Interfaces/SJSpecimen.h,v 2.3 2002/04/19 18:18:45 sj Exp $
// Oleksandr Shyrokov shirokov@unh.edu 10/03/2001 UNH
// For Amors project
// SJSpecimen.h: interface for the CSJSpecimen class.

#if !defined(SJSPECIMEN_H_INCLUDED)
#define SJSPECIMEN_H_INCLUDED

#pragma warning(disable:4786)
#include <deque>

#include "SJObjectInfoList.h"
#include "SJImageList.h"
#include "SJIniFile.h"
#include "AllConstants.h"

// Application should have one instance of this object
// And everything goes thoru it.
class CSJSpecimen
{
protected:
	CSJImageList		m_ListOfImages;
	CSJImageList		m_TempImages;
	CSJObjectInfoList	m_Objects;
	// If any module wants to give any data to another module it
	// could be done through this variable.
	CSJObjectInfo		m_Vars;
	CSJIniFile			m_IniFile;
	int*				m_piStage;
	float*				m_pfProgress;
	bool*				m_pyAbort;
	std::deque<std::string> m_LogRep;
	typedef int(*fntDisplay)(CSJSpecimen&);
	fntDisplay			m_addrDisplay;
public:
	void SetDisplayAddress(fntDisplay addr){m_addrDisplay=addr;};
	int SpecialDisplay(CSJSpecimen& NewSpec){return m_addrDisplay(NewSpec);};
	CSJSpecimen();
	virtual ~CSJSpecimen();
	CSJSpecimen &operator=(CSJSpecimen &fromobj);
	int GetNumberOfLayers(){return m_ListOfImages.GetLength();};
	int GetWidthOfLayer()
		{
			if(!GetNumberOfLayers())
				return m_ListOfImages.GetImage(0)->GetWidth();
			else
				return 0;
		};
	int GetHeightOfLayer()
		{
			if(!GetNumberOfLayers())
				return m_ListOfImages.GetImage(0)->GetHeight();
			else 
				return 0;
		};
	CSJImageList* GetImageList(){return &m_ListOfImages;};
	CSJImageList* GetTempImages(){return &m_TempImages;};
	CSJObjectInfoList* GetObjects(){return &m_Objects;};
	CSJObjectInfo* GetVars(){return &m_Vars;};
	CSJIniFile* GetIniFile(){return &m_IniFile;};
	BOOL ReportProgress(int iStage,float fPercentage);
	void SetReportVars(int* piStage, float* pfProgress);
	void SetAbortVar(bool* pyAbort){m_pyAbort=pyAbort;};
	bool IsAborted(){if(m_pyAbort)return *m_pyAbort;else return false;};
	void Abort(){if(m_pyAbort)*m_pyAbort=true;};
	void Reset();
	bool IsLogEmpty(){return m_LogRep.empty();};
	void AddLogMessage(std::string str){m_LogRep.push_back(str);};
	std::string GetLogMessage(){std::string str=m_LogRep.front();m_LogRep.pop_front();return str;};
};

#endif // !defined(SJSPECIMEN_H_INCLUDED)
