// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
//$Header$
// This's a template for Acquisition Plug-In. 

// Create a new project with MFC AppWizard(dll) 
// Choose  MFC Extension DLL (using shared MFC DLL)
// Place the contents of this file instead of automaticly created one.
// Substitute NAME_IN_ACQ_TEMPLATE with the real name  of Plug-In
// Remove "'" from $'Revision'$ in order to have correct substitution with CVS or edit it manually

// Add "../../../Interfaces/Interfaces.lib" to the Project Settings->Link->object/library modules
// Add "copy Debug\NAME_IN_ACQ_TEMPLATE.dll path\Amors\PlugIns\NAME_IN_ACQ_TEMPLATED.dll"
// to the Project Settings->Post-build step

// Non zero value returned by any function means a successful finishing

#include "stdafx.h"		// Should be used in order to have precomipled headers
#include <afxdllx.h>		// It's a dll with MFC extension
// String support
#pragma warning(disable:4786)
#include <string>

// Definitions of interface objects
#include "../../../Interfaces/Interfaces_def.h"

// Include any MFC dialog here
//#include "YourSetupDlg.h"

// If you want to store preferences in the global Ini file
// It's convinuent to use such definitions
#define NAME_IN_ACQ_TEMPLATE_INI_SECTION "NAME_IN_ACQ_TEMPLATE_CONFIG"
#define NAME_IN_ACQ_TEMPLATE_VARIABLE1 "NAME_IN_ACQ_TEMPLATE_VARIABLE1"
#define NAME_IN_ACQ_TEMPLATE_VARIABLE2 "NAME_IN_ACQ_TEMPLATE_VARIABLE2"

static AFX_EXTENSION_MODULE NAME_IN_ACQ_TEMPLATEDLL = { NULL, NULL };

// Standard initializing routin.
extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("NAME_IN_ACQ_TEMPLATE.DLL Initializing!\n");
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(NAME_IN_ACQ_TEMPLATEDLL, hInstance))
			return 0;
		new CDynLinkLibrary(NAME_IN_ACQ_TEMPLATEDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("NAME_IN_ACQ_TEMPLATE.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(NAME_IN_ACQ_TEMPLATEDLL);
	}
	return 1;   // ok
}

EXPORT_FNT_MARCO int GetType()
{
// Should return type of the DLL, see AllConstants.h in Interface library for
// all defined types in "enum Plugins_types"
	return SJ_PLGUIN_TYPE_ACQ;
}

EXPORT_FNT_MARCO int GetInfo(std::string& Info)
{
#ifdef _DEBUG
	Info="NAME_IN_ACQ_TEMPLATE ver $'Revision'$ (Debug)";
#else
	Info="NAME_IN_ACQ_TEMPLATE ver $'Revision'$ ";
#endif

// If you want to use SetupDlg you must return 	
// SJ_MFC_DIALOG_SETUP value from this function
//	return SJ_MFC_DIALOG_SETUP;
// Otherwise:
	return SJ_NO_SETUP_DIALOG;
}

EXPORT_FNT_MARCO int SetupDll(const char *iniName)
{
	// Use this object to save preferences
	CSJIniFile IniConfig;
	// Check that we have alocated memory for the name
	if(!iniName)return 0;
	std::string strIniFN=iniName;

	IniConfig.SetPath(strIniFN);
	IniConfig.ReadFile();

//	CYourSetupDlg SetupDlg;
	// If we have this value in INI file load it and show it in the window
	// Read varibles from INI file and initialize dialog variables
//	SetupDlg.m_strVariable1=IniConfig.GetValue(NAME_IN_ACQ_TEMPLATE_INI_SECTION,NAME_IN_ACQ_TEMPLATE_VARIABLE1).data();
//	SetupDlg.m_iVariable2=IniConfig.GetValueI(NAME_IN_ACQ_TEMPLATE_INI_SECTION,NAME_IN_ACQ_TEMPLATE_VARIABLE2);
//	if(SetupDlg.DoModal()==IDOK)
	{
		// If dialog has been successfully closed write  these values to the Ini File
//		IniConfig.SetValue(NAME_IN_ACQ_TEMPLATE_INI_SECTION,NAME_IN_ACQ_TEMPLATE_VARIABLE1,SetupDlg.m_strVariable1.GetBuffer(SetupDlg.m_strVariable1.GetLength()));
//		IniConfig.SetValueI(NAME_IN_ACQ_TEMPLATE_INI_SECTION,NAME_IN_ACQ_TEMPLATE_VARIABLE2,SetupDlg.m_iVariable2);
//		IniConfig.WriteFile();
		// Non zero value means a successful setup (used in Reaserch mode)
	return 1;
	}
	return 0;
}

// Initializes whatever you need for work. Should be called once, or in pair with Done
EXPORT_FNT_MARCO int Init(CSJSpecimen &Specimen)
{
	// Put any code for initialization here

	return 1;
}

// Shuts down hardware or whatever you need to do here. Cleaning and so on...
EXPORT_FNT_MARCO int Done(CSJSpecimen &Specimen)
{
	// Put any code for deinitialization here

	return 1;
}

// Acquire a data into Specimen object, iNum gives the data set to acquire.
// For here iNum is ignored
EXPORT_FNT_MARCO int Acquire(CSJSpecimen &Specimen,int iNum)
{
	// Variable to report progress in the module
	float fPorgress=0;
	// Assign reprort varialbe
	Specimen.ReportProgress(SJ_PLGUIN_TYPE_ACQ,fPorgress);

	// Put the code for acquistion here
	
	return 1;	
}
