// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
//$Header: c:\\users\\sj\\CVS/Thesis/PlugIns/Acq/FromFileAcq/FromFileAcq.cpp,v 1.5 2002/05/27 22:29:29 sj Exp $
// FromFileAcq.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include <afxdllx.h>

// Couses problems when std is used  :((((
//#ifdef _DEBUG
//#define new DEBUG_NEW
//#undef THIS_FILE
//static char THIS_FILE[] = __FILE__;
//#endif

#include "../../../Interfaces/Interfaces_def.h"

#define ACQ_INI_SECTION "DUMMY_ACQ_CONFIG"
#define ACQ_DESC_FILE "Desc_file"
#define ACQ_INI_KEY_INVERT "Invert"

static AFX_EXTENSION_MODULE FromFileAcqDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("FROMFILEACQ.DLL Initializing!\n");
		
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(FromFileAcqDLL, hInstance))
			return 0;

		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

		new CDynLinkLibrary(FromFileAcqDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("FROMFILEACQ.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(FromFileAcqDLL);
	}
	return 1;   // ok
}

EXPORT_FNT_MARCO int GetType()
{
	return SJ_PLGUIN_TYPE_ACQ;
}

EXPORT_FNT_MARCO int GetInfo(std::string& Info)
{
#ifdef _DEBUG
	Info="FromFileAcq ($Revision: 1.5 $)(Debug)";
#else
	Info="FromFileAcq ($Revision: 1.5 $)";
#endif
	return SJ_NO_SETUP_DIALOG;
}

EXPORT_FNT_MARCO int SetupDll(const char *iniName)
{
	return 1;
}

// Initializes whatever you need for work. Should be called once, or in pair with Done
EXPORT_FNT_MARCO int Init(CSJSpecimen &Specimen)
{
	return 1;
}

// Shuts down hardware or whatever you need to do here. Cleaning and so on...
EXPORT_FNT_MARCO int Done(CSJSpecimen &Specimen)
{
	return 1;
}

// Acquire a data into Specimen object, iNum gives the data set to acquire.
// For here iNum is ignored
EXPORT_FNT_MARCO int Acquire(CSJSpecimen &Specimen,int iNum)
{
	// Choose the file to be loadded
	CFileDialog openDlg(true, "*.tif", "", OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
						"Pictures (*.tif)|*.tif|All Files (*.*)|*.*||");
	// if don't want to load file abort execution
	if (openDlg.DoModal() != IDOK)
	{
		Specimen.Abort();
		return 0;
	}
	std::string strHelp=openDlg.GetPathName().GetBuffer(openDlg.GetPathName().GetLength());
	Specimen.GetVars()->SetValue("Image0",strHelp);
	// Ask if we want to invert image
	if(MessageBox(NULL,"Should image be inverted?","Question...",MB_YESNO|MB_ICONQUESTION)==IDNO)
		// Don't invert it
		Specimen.GetVars()->SetValue("InvertImage",0);
	else
		// Invert it
		Specimen.GetVars()->SetValue("InvertImage",1);
	CSJImage Im;
	std::string strFN=(Specimen.GetVars()->GetValue("Image0"));
	Im.CreateFromFile(strFN.data());
	Specimen.AddLogMessage("Loaded Image: "+strFN);
	if(Specimen.GetVars()->GetValueI("InvertImage")==1)Im.Invert();
	Specimen.GetImageList()->Add(Im);
	Specimen.GetVars()->SetValue("From File Acquisition",1);
	return 1;	
}
