// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
#if !defined(DIBBUFFER_H_INCLUDED)
#define DIBBUFFER_H_INCLUDED

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vfw.h>
#include "../../../Interfaces/Interfaces_def.h"

class CDibBuffer  
{
public:
	// Copy Constructor
	CDibBuffer(CDibBuffer &from);
	CDibBuffer();
	virtual ~CDibBuffer();
	CDibBuffer &operator=(CDibBuffer &spec);
	BOOL Create(int iWidth, int iHeight,int iColorDepth=COLOR_DEPTH_8BITS, BOOL yOpenDib=TRUE);
	BOOL CreateFrom(CSJImage &Im);
	BOOL CreateFrom(CSJBuffer &Buf);
	int GetSize(){return m_iWidth*m_iHeight*m_iBytesPP;};
	void Draw(HDC hdc, int xDst, int yDst, int dxDst, int dyDst, int xSrc, int ySrc, int dxSrc, int dySrc, UINT wFlags=0);
	int GetWidth(){return m_iWidth;};
	int GetHeight(){return m_iHeight;};
	int GetBytesPP(){return m_iBytesPP;};
	void InversePal();
protected:
	void SetByte(int iX, int iY, byte bValue);
	// Working with Dib here
	HDRAWDIB			m_hDD;                         //Handle to DrawDIB interface
	BITMAPINFOHEADER*	m_ptDIBHdr;
	char				m_pcDIBHdr[sizeof(BITMAPINFOHEADER) + 256 * sizeof(RGBQUAD)];
	// Buffer array!
	byte*				m_pBuffer;
	int					m_iWidth;
	int					m_iHeight;
	// for dib displaying width should have the multiple of 4
	int					m_iEffWidth;
	int					m_iBytesPP;
	BOOL				m_yDibOpened;
	int					m_iColorDepth;
};

#endif // !defined(DIBBUFFER_H_INCLUDED)
