// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
// DisplayWindow.cpp : implementation file
//

#include "stdafx.h"
#include <math.h>
#include <fstream>
#include <iomanip>
#include "DisplayWindow.h"


/////////////////////////////////////////////////////////////////////////////
// CDisplayWindow dialog


CDisplayWindow::CDisplayWindow(CWnd* pParent /*=NULL*/)
	: CDialog(CDisplayWindow::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDisplayWindow)
	//}}AFX_DATA_INIT
	m_pSpecimen = NULL;
	m_iCurrentlyShownImage=-1;
	m_iTotalImages = 0;
	m_iTotalObj = 0;
	m_iCurrentObj=-1;
	m_fHScale=1;
	m_fVScale=1;
	m_yFit=false;
	m_yShowAllObj=false;
	m_fZoom=1;
	m_yTransformed=false;
	m_yImHist=false;
	m_Markers.clear();
	m_Markers.reserve(100);
}

void CDisplayWindow::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDisplayWindow)
	DDX_Control(pDX, IDC_DISPLAY_WINDOW_CB_TEMP_IMAGES, m_ctrlCBTemp);
	DDX_Control(pDX, IDC_DISPLAY_WINDOW_EDIT_INFO, m_ctrlEditInfo);
	DDX_Control(pDX, IDC_DISPLAY_WINDOW_BTN_PREV_OBJ, m_btnPrevObj);
	DDX_Control(pDX, IDC_DISPLAY_WINDOW_BTN_PREV, m_btnPrev);
	DDX_Control(pDX, IDC_DISPLAY_WINDOW_BTN_NEXT_OBJ, m_btnNextObj);
	DDX_Control(pDX, IDC_DISPLAY_WINDOW_BTN_NEXT, m_btnNext);
	DDX_Control(pDX, IDC_DISPLAY_WINDOW_BTN_CENTER_OBJECT, m_btnCenterObj);
	DDX_Control(pDX, IDC_DISPLAY_WINDOW_BTN_SHOW_TRANSFORMED, m_btnShowTransformed);
	DDX_Control(pDX, IDC_DISPLAY_WINDOW_LABLE_ZOOM, m_ctrlLableZoom);
	DDX_Control(pDX, IDC_DISPLAY_WINDOW_CB_SHOWALLOBJ, m_ctrlCBAllObj);
	DDX_Control(pDX, IDC_DISPLAY_WINDOW_SCRL_V, m_ctrlVScrl);
	DDX_Control(pDX, IDC_DISPLAY_WINDOW_SCRL_H, m_ctrlHScrl);
	DDX_Control(pDX, IDC_DISPLAY_WINDOW_OBJ_INF, m_ctrlObjInf);
	DDX_Control(pDX, IDC_DISPLAY_WINDOW_SHOWN_IM, m_ctrlShownIm);
	DDX_Control(pDX, IDC_DISPLAY_WINDOW_PICTURE, m_ctrlPicture);
	DDX_Control(pDX, IDC_DISPLAY_WINDOW_CB_FIT, m_cbFit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDisplayWindow, CDialog)
	//{{AFX_MSG_MAP(CDisplayWindow)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_DISPLAY_WINDOW_CB_FIT, OnDisplayWindowCbFit)
	ON_BN_CLICKED(IDC_DISPLAY_WINDOW_BTN_PREV, OnDisplayWindowBtnPrev)
	ON_BN_CLICKED(IDC_DISPLAY_WINDOW_BTN_NEXT, OnDisplayWindowBtnNext)
	ON_BN_CLICKED(IDC_DISPLAY_WINDOW_BTN_PREV_OBJ, OnDisplayWindowBtnPrevObj)
	ON_BN_CLICKED(IDC_DISPLAY_WINDOW_BTN_NEXT_OBJ, OnDisplayWindowBtnNextObj)
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_BN_CLICKED(IDC_DISPLAY_WINDOW_CB_SHOWALLOBJ, OnDisplayWindowCbShowallobj)
	ON_BN_CLICKED(IDC_DISPLAY_WINDOW_BTN_INFO, OnDisplayWindowBtnInfo)
	ON_BN_CLICKED(IDC_DISPLAY_WINDOW_BTN_ZOOM_IN, OnDisplayWindowBtnZoomIn)
	ON_BN_CLICKED(IDC_DISPLAY_WINDOW_BTN_ZOOM_OUT, OnDisplayWindowBtnZoomOut)
	ON_BN_CLICKED(IDC_DISPLAY_WINDOW_BTN_CENTER_OBJECT, OnDisplayWindowBtnCenterObject)
	ON_BN_CLICKED(IDC_DISPLAY_WINDOW_BTN_ZOOM_RESET, OnDisplayWindowBtnZoomReset)
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_DISPLAY_WINDOW_BTN_SHOW_TRANSFORMED, OnDisplayWindowBtnShowTransformed)
	ON_BN_CLICKED(IDC_DISPLAY_WINDOW_PICTURE, OnDisplayWindowPicture)
	ON_WM_LBUTTONUP()
	ON_BN_CLICKED(IDC_DISPLAY_WINDOW_BTN_HIST, OnDisplayWindowBtnHist)
	ON_WM_LBUTTONDBLCLK()
	ON_WM_RBUTTONDBLCLK()
	ON_BN_CLICKED(IDC_DISPLAY_WINDOW_BTN_DEL_MARKERS, OnDisplayWindowBtnDelMarkers)
	ON_BN_CLICKED(IDC_DISPLAY_WINDOW_CB_TEMP_IMAGES, OnDisplayWindowCbTempImages)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDisplayWindow message handlers

BOOL CDisplayWindow::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_Markers.clear();
	m_Markers.reserve(100);

	m_uTimerID = SetTimer(0x451, 100, NULL);
	m_cbFit.SetCheck(m_yFit);
	m_ctrlCBAllObj.SetCheck(m_yShowAllObj);
	// Set scroll bars info (everything is in percent scale!
	SCROLLINFO info;
	m_ctrlHScrl.GetScrollInfo(&info, SIF_ALL);
	info.nMin=0;
	info.nMax=109;
	info.nPage=10;
	info.nPos=0;
	m_ctrlHScrl.SetScrollInfo(&info);
	m_ctrlVScrl.SetScrollInfo(&info);
	if(m_pSpecimen==NULL)return false;
	if(!AssignImage())return false;
	if(m_iCurrentObj>=0 && !m_pSpecimen->GetObjects()->GetObjectInfo(m_iCurrentObj)->GetTransformed()->IsEmpty())
		m_btnShowTransformed.EnableWindow();
	else
		m_btnShowTransformed.EnableWindow(false);
	if(m_pSpecimen->GetTempImages()->GetLength()==0)
		m_ctrlCBTemp.EnableWindow(false);
	else
		m_ctrlCBTemp.EnableWindow(true);
	UpdateImInfo();
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CDisplayWindow::OnDestroy() 
{
	CDialog::OnDestroy();
	KillTimer(m_uTimerID);
	m_dlgInfo.DestroyWindow();
	m_dlgHistogram.DestroyWindow();
}

void CDisplayWindow::OnTimer(UINT nIDEvent) 
{
	UpdateDib();
	CDialog::OnTimer(nIDEvent);
}

void CDisplayWindow::UpdateDib()
{
	// Nothing to draw if there's no specimen assigned
	if (m_pSpecimen == NULL)
		return;
	
	CDC *cDc = m_ctrlPicture.GetDC();
	CRect clRect;
	m_ctrlPicture.GetClientRect(clRect);
	
	int		iDestWidth	= m_DibBuffer.GetWidth();
	int		iDestHeight = m_DibBuffer.GetHeight();
	int		iDestTop	= 0;
	int		iDestLeft	= 0;

	// 4 cases: Fit, !Fit, for them Image is smaller or larger
	if (!m_cbFit.GetCheck())
	{
		SCROLLINFO info;
		iDestWidth=clRect.right;
		iDestHeight=clRect.bottom;
		// Image is larger then the rect of drawing
		if(m_ctrlHScrl.IsWindowVisible())
		{
			m_ctrlHScrl.GetScrollInfo(&info, SIF_ALL);
			iDestLeft=(int)(info.nTrackPos*m_fHScale);
		}
		if(m_ctrlVScrl.IsWindowVisible())
		{
			m_ctrlVScrl.GetScrollInfo(&info, SIF_ALL);
			iDestTop=(int)(info.nTrackPos*m_fVScale);
		}
	}
	m_DibBuffer.Draw(	cDc->GetSafeHdc(),
						0,0, 
						clRect.right, clRect.bottom,
						iDestLeft, iDestTop, 
						(int)(iDestWidth*m_fZoom), (int)(iDestHeight*m_fZoom));
	if(!m_yTransformed)ShowObjects(cDc,iDestLeft,iDestTop);
	ReleaseDC(cDc);
}

void CDisplayWindow::ShowObjects(CDC* cDc,int iDestLeft/*=0*/, int iDestTop/*=0*/)
{
	if(m_iTotalObj<=0)return;
	// Create Pen to draw the Blob Rectangle
	CPen aPen;
	// Create brushes and pens
	if (!aPen.CreatePen(PS_SOLID, 1, RGB(255,0,0)))
	{
		// Pen creation failed
		AfxMessageBox("Pen creation failed", MB_OK);
		AfxAbort();
	}
	// Select the pen
	CPen *pOldPen=cDc->SelectObject(&aPen);
	// Select the brush (just have an empty rectangle)
	CBrush* pOldBrush=(CBrush*)cDc->SelectStockObject(NULL_BRUSH);
	float	fScaleX = 1,
			fScaleY = 1;
	CRect clRect;
	m_ctrlPicture.GetClientRect(clRect);
	if(m_yFit)
	{
		fScaleX = (float)clRect.right/m_DibBuffer.GetWidth();
		fScaleY = (float)clRect.bottom/m_DibBuffer.GetHeight();
	}
	else
	{
		fScaleX=1/m_fZoom;
		fScaleY=1/m_fZoom;
	}
	// Draw selected first
	CSJObjectInfo* ObjInfo=m_pSpecimen->GetObjects()->GetObjectInfo(m_iCurrentObj);
	// Check if it's valid for histogram
	BOOL yVisHist=m_dlgHistogram.IsWindowVisible();
	if(!yVisHist && !m_yTemp)
	{
		CRect ObjRect(	(int)((ObjInfo->Rect.m_iLeft-3)*fScaleX),
						(int)((ObjInfo->Rect.m_iTop-3)*fScaleY),
						(int)((ObjInfo->Rect.m_iRight+3)*fScaleX),
						(int)((ObjInfo->Rect.m_iBottom+3)*fScaleY));
		ObjRect-=CPoint((int)(iDestLeft/m_fZoom),(int)(iDestTop/m_fZoom));
		ObjRect.IntersectRect(clRect,ObjRect);
		cDc->Rectangle(ObjRect);
	}
	// Draw the rest if needed
	if(m_yShowAllObj)
	{
		// Another color
		CPen bPen;
		// Create brushes and pens
		if (!bPen.CreatePen(PS_SOLID, 1, RGB(0,255,255)))
		{
			// Pen creation failed
			AfxMessageBox("Pen creation failed", MB_OK);
			AfxAbort();
		}
		// Select the pen
		cDc->SelectObject(&bPen);
		for(int iCount=0;iCount<m_iTotalObj;iCount++)
		{
			// don't draw selected object
			if(!yVisHist && iCount==m_iCurrentObj && !m_yTemp)continue;
			ObjInfo=m_pSpecimen->GetObjects()->GetObjectInfo(iCount);
			// First check if this object corresponds to the currently shown image
			if(m_iCurrentlyShownImage!=ObjInfo->GetValueI("OriginalImage"))continue;
			// Check if it's valid for histogram
			if(!m_yImHist && m_dLeft!=m_dRight)
			{
				double dVal=ObjInfo->GetValueF(m_strSelectedHist.GetBuffer(m_strSelectedHist.GetLength()+1));
				if(dVal<m_dLeft || dVal>m_dRight)continue;
			}
			CRect ObjRect(	(int)((ObjInfo->Rect.m_iLeft-3)*fScaleX),
							(int)((ObjInfo->Rect.m_iTop-3)*fScaleY),
							(int)((ObjInfo->Rect.m_iRight+3)*fScaleX),
							(int)((ObjInfo->Rect.m_iBottom+3)*fScaleY));
			//ObjRect-=CPoint(iDestLeft,iDestTop);
			ObjRect-=CPoint((int)(iDestLeft/m_fZoom),(int)(iDestTop/m_fZoom));
			ObjRect.IntersectRect(clRect,ObjRect);
			cDc->Rectangle(ObjRect);
		}
	}
	CPen YellowPen;
	CPen GreenPen;
	// Create Yellow and green pens
	if (!YellowPen.CreatePen(PS_SOLID, 1, RGB(255,255,0)))
	{
		// Pen creation failed
		AfxMessageBox("Pen creation failed", MB_OK);
		AfxAbort();
	}
	// Create Yellow and green pens
	if (!GreenPen.CreatePen(PS_SOLID, 1, RGB(0,255,0)))
	{
		// Pen creation failed
		AfxMessageBox("Pen creation failed", MB_OK);
		AfxAbort();
	}
	// Select the pen
	cDc->SelectObject(&YellowPen);
	cDc->SelectObject(&GreenPen);
	// Show markers here
	for(Marker_vector_type_iter pos=m_Markers.begin();pos!=m_Markers.end();++pos)
	{
		if(pos->GetType()==MARKER_ADD)
			cDc->SelectObject(&GreenPen);
		else
			cDc->SelectObject(&YellowPen);
		CRect MarkRect(	(int)((pos->GetX()-4)*fScaleX),
						(int)((pos->GetY()-4)*fScaleY),
						(int)((pos->GetX()+4)*fScaleX),
						(int)((pos->GetY()+4)*fScaleY));
		MarkRect-=CPoint((int)(iDestLeft/m_fZoom),(int)(iDestTop/m_fZoom));
		MarkRect.IntersectRect(clRect,MarkRect);
		cDc->Ellipse(MarkRect);
	}

	cDc->SelectObject(pOldPen);
	cDc->SelectObject(pOldBrush);

}

void CDisplayWindow::OnDisplayWindowCbFit() 
{
	if(m_cbFit.GetCheck()==1)m_yFit=true;
	else m_yFit=false;
	if(m_yFit)
	{
		m_fZoom=1.0f;
	}
	AdjustScrolls();
	//m_ctrlHScrl.ShowWindow(!m_yFit);
	//m_ctrlVScrl.ShowWindow(!m_yFit);
	//Invalidate();
}

void CDisplayWindow::AssignSpecimen(CSJSpecimen *pSpecimen/*=NULL*/)
{
	m_pSpecimen = pSpecimen;
	m_iCurrentlyShownImage = 0;
	m_iTotalImages = m_pSpecimen->GetImageList()->GetLength();
	//m_ctrlSpinImage.SetRange(0,m_iTotalImages);
	m_iTotalObj = m_pSpecimen->GetObjects()->GetLength();
	if(m_iTotalObj>0)	m_iCurrentObj=0;
		else			m_iCurrentObj=-1;
	m_dlgInfo.AssignSpecimen(m_pSpecimen);
}

void CDisplayWindow::OnDisplayWindowBtnPrev() 
{
	// if(m_pSpecimen)m_DibBuffer.InversePal();
	if (m_pSpecimen && m_iCurrentlyShownImage > 0)
	{
		m_iCurrentlyShownImage--;
		AssignImage();
		UpdateImInfo();
		Invalidate();
	}
}

void CDisplayWindow::OnDisplayWindowBtnNext() 
{
	if (m_pSpecimen && ((m_yTemp && m_iCurrentlyShownImage < m_pSpecimen->GetTempImages()->GetLength()-1)||(!m_yTemp && m_iCurrentlyShownImage < m_pSpecimen->GetImageList()->GetLength() - 1)))
	{
		m_iCurrentlyShownImage++;
		AssignImage();
		UpdateImInfo();
		Invalidate();
	}
}
#define ADD_NEW_LINE(x) x.Insert(x.GetLength(),13);x.Insert(x.GetLength(),10)

void CDisplayWindow::UpdateImInfo()
{
	CString strH="";
	if(m_yTemp)
		strH.Format("Image %d/%d", m_iCurrentlyShownImage + 1, m_pSpecimen->GetTempImages()->GetLength());
	else
		strH.Format("Image %d/%d", m_iCurrentlyShownImage + 1, m_pSpecimen->GetImageList()->GetLength());
	m_ctrlShownIm.SetWindowText(strH);
	strH.Format("Obj %d/%d", m_iCurrentObj + 1, m_iTotalObj);
	m_ctrlObjInf.SetWindowText(strH);
	strH.Format("Zoom %f",m_fZoom);
	m_ctrlLableZoom.SetWindowText(strH);
	// Print all info
	int iPlus=0;
	strH="";
	for(Marker_vector_type_iter pos=m_Markers.begin();pos!=m_Markers.end();++pos)
	{
		if(pos->GetType()==MARKER_ADD)
			iPlus++;
		else
			iPlus--;
	}
	strH+=Format("Number of objects with marks=%d",m_iTotalObj+iPlus).data();
	ADD_NEW_LINE(strH);
	strH+="-------";
	ADD_NEW_LINE(strH);
	if(m_iTotalObj>0 && m_iCurrentObj>=0)
	{
		strH+=	Format("Left=%d; Top=%d; Right=%d; Bottom=%d;",
				m_pSpecimen->GetObjects()->GetObjectInfo(m_iCurrentObj)->Rect.m_iLeft,
				m_pSpecimen->GetObjects()->GetObjectInfo(m_iCurrentObj)->Rect.m_iTop,
				m_pSpecimen->GetObjects()->GetObjectInfo(m_iCurrentObj)->Rect.m_iRight,
				m_pSpecimen->GetObjects()->GetObjectInfo(m_iCurrentObj)->Rect.m_iBottom).data();
		for(int i=0;i<m_pSpecimen->GetObjects()->GetObjectInfo(m_iCurrentObj)->GetNumVars();i++)
			strH+=	CString(m_pSpecimen->GetObjects()->GetObjectInfo(m_iCurrentObj)->GetNameAt(i).data())+
					"="+
					CString(m_pSpecimen->GetObjects()->GetObjectInfo(m_iCurrentObj)->GetValueAt(i).data())+
					"; ";
		m_ctrlEditInfo.SetWindowText(strH);
	}
}

bool CDisplayWindow::AssignImage()
{
	if(m_pSpecimen==NULL)return false;
	int iRet=0;
	if(m_yTemp)
		iRet=m_DibBuffer.CreateFrom(*m_pSpecimen->GetTempImages()->GetImage(m_iCurrentlyShownImage));
	else
		iRet=m_DibBuffer.CreateFrom(*m_pSpecimen->GetImageList()->GetImage(m_iCurrentlyShownImage));
	if(!iRet)return false;
	AdjustScrolls();
	return true;
}

void CDisplayWindow::AdjustScrolls()
{
	CRect clRect;
	m_ctrlPicture.GetClientRect(clRect);
	
	// calculate pixels per percent to shift image in the window
	m_fHScale=(float)(m_DibBuffer.GetWidth()/m_fZoom-clRect.right)/100*m_fZoom;
	m_fVScale=(float)(m_DibBuffer.GetHeight()/m_fZoom-clRect.bottom)/100*m_fZoom;
	// if picture is too small, use factor of 1
	if(m_fHScale<0)m_fHScale=-m_fHScale;
	if(m_fVScale<0)m_fVScale=-m_fVScale;
	// if state of scroll bars was changed invalidate picture.
	BOOL	yH=m_ctrlHScrl.IsWindowVisible(),
			yV=m_ctrlVScrl.IsWindowVisible();
	// Show/hide scrolls
	if(m_DibBuffer.GetWidth()/m_fZoom>clRect.right && !m_yFit)
		m_ctrlHScrl.ShowWindow(TRUE);
	// Image is smaller
	else
		m_ctrlHScrl.ShowWindow(FALSE);
	if(m_DibBuffer.GetHeight()/m_fZoom>clRect.bottom && !m_yFit)
		m_ctrlVScrl.ShowWindow(TRUE);
	// Image is smaller
	else
		m_ctrlVScrl.ShowWindow(FALSE);
	// Redraw background
	if(	yH!=m_ctrlHScrl.IsWindowVisible() ||
		yV!=m_ctrlVScrl.IsWindowVisible() ||
		!yH || !yV)
			Invalidate();
}

void CDisplayWindow::OnDisplayWindowBtnPrevObj() 
{
	if (m_pSpecimen && m_iCurrentObj>0 && m_iTotalObj > 0)
	{
		m_iCurrentObj--;
		//if(m_yShowObjOnly)AssignImage();
		UpdateImInfo();
		Invalidate();
	}	
}

void CDisplayWindow::OnDisplayWindowBtnNextObj()
{
	if (m_pSpecimen && m_iCurrentObj < m_pSpecimen->GetObjects()->GetLength() - 1 && m_iTotalObj > 0)
	{
		m_iCurrentObj++;
		if(m_pSpecimen->GetObjects()->GetObjectInfo(m_iCurrentObj)->GetTransformed()->IsEmpty())
			m_btnShowTransformed.EnableWindow(false);
		else
			m_btnShowTransformed.EnableWindow();
		UpdateImInfo();
		Invalidate();
	}	
}

void CDisplayWindow::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// Get the minimum and maximum scroll-bar positions.
	int minpos;
	int maxpos;
	pScrollBar->GetScrollRange(&minpos, &maxpos); 
	maxpos = pScrollBar->GetScrollLimit();
	
	// Get the current position of scroll box.
	int curpos = pScrollBar->GetScrollPos();
	
	// Determine the new position of scroll box.
	switch (nSBCode)
	{
		case SB_LEFT:      // Scroll to far left.
			curpos = minpos;
			break;
			
		case SB_RIGHT:      // Scroll to far right.
			curpos = maxpos;
			break;
			
		case SB_ENDSCROLL:   // End scroll.
			break;
			
		case SB_LINELEFT:      // Scroll left.
			if (curpos > minpos)
				curpos--;
			break;
			
		case SB_LINERIGHT:   // Scroll right.
			if (curpos < maxpos)
				curpos++;
			break;
			
		case SB_PAGELEFT:    // Scroll one page left.
			{
				// Get the page size. 
				SCROLLINFO   info;
				pScrollBar->GetScrollInfo(&info, SIF_ALL);
				
				if (curpos > minpos)
					curpos = max(minpos, curpos - (int) info.nPage);
			}
			break;
			
		case SB_PAGERIGHT:      // Scroll one page right.
			{
				// Get the page size. 
				SCROLLINFO   info;
				pScrollBar->GetScrollInfo(&info, SIF_ALL);
				
				if (curpos < maxpos)
					curpos = min(maxpos, curpos + (int) info.nPage);
			}
			break;
			
		case SB_THUMBPOSITION: // Scroll to absolute position. nPos is the position
			curpos = nPos;      // of the scroll box at the end of the drag operation.
			break;
			
		case SB_THUMBTRACK:   // Drag scroll box to specified position. nPos is the
			curpos = nPos;     // position that the scroll box has been dragged to.
			break;
	}
	
	// Set the new position of the thumb (scroll box).
	pScrollBar->SetScrollPos(curpos);
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CDisplayWindow::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// Get the minimum and maximum scroll-bar positions.
	int minpos;
	int maxpos;
	pScrollBar->GetScrollRange(&minpos, &maxpos); 
	maxpos = pScrollBar->GetScrollLimit();
	
	// Get the current position of scroll box.
	int curpos = pScrollBar->GetScrollPos();
	
	// Determine the new position of scroll box.
	switch (nSBCode)
	{
		case SB_TOP:      // Scroll to far left.
			curpos = minpos;
			break;
			
		case SB_BOTTOM:      // Scroll to far right.
			curpos = maxpos;
			break;
			
		case SB_ENDSCROLL:   // End scroll.
			break;
			
		case SB_LINEUP:      // Scroll left.
			if (curpos > minpos)
				curpos--;
			break;
			
		case SB_LINEDOWN:   // Scroll right.
			if (curpos < maxpos)
				curpos++;
			break;
			
		case SB_PAGEUP:    // Scroll one page left.
			{
				// Get the page size. 
				SCROLLINFO   info;
				pScrollBar->GetScrollInfo(&info, SIF_ALL);
				
				if (curpos > minpos)
					curpos = max(minpos, curpos - (int) info.nPage);
			}
			break;
			
		case SB_PAGEDOWN:      // Scroll one page right.
			{
				// Get the page size. 
				SCROLLINFO   info;
				pScrollBar->GetScrollInfo(&info, SIF_ALL);
				
				if (curpos < maxpos)
					curpos = min(maxpos, curpos + (int) info.nPage);
			}
			break;
			
		case SB_THUMBPOSITION: // Scroll to absolute position. nPos is the position
			curpos = nPos;      // of the scroll box at the end of the drag operation.
			break;
			
		case SB_THUMBTRACK:   // Drag scroll box to specified position. nPos is the
			curpos = nPos;     // position that the scroll box has been dragged to.
			break;
	}
	
	// Set the new position of the thumb (scroll box).
	pScrollBar->SetScrollPos(curpos);
	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CDisplayWindow::OnDisplayWindowCbShowallobj() 
{
	if(m_ctrlCBAllObj.GetCheck()==1)
		m_yShowAllObj=true;
	else 
		m_yShowAllObj=false;
	AssignImage();
	UpdateImInfo();
}

void CDisplayWindow::OnDisplayWindowBtnInfo() 
{
	m_dlgInfo.ShowWindow(!m_dlgInfo.IsWindowVisible());
}

void CDisplayWindow::OnDisplayWindowBtnZoomIn() 
{
	if(m_yFit)return;
	m_fZoom=m_fZoom/2;
	AdjustScrolls();
	UpdateImInfo();
}

void CDisplayWindow::OnDisplayWindowBtnZoomOut() 
{
	if(m_yFit)return;
	m_fZoom=m_fZoom*2;
	AdjustScrolls();
	UpdateImInfo();
}

void CDisplayWindow::OnDisplayWindowBtnCenterObject() 
{
#define ZOOM_MULTIPLIER 3
	CSJObjectInfo* pInfo=m_pSpecimen->GetObjects()->GetObjectInfo(m_iCurrentObj);
	// Set image for which this object was taken
	m_iCurrentlyShownImage=pInfo->GetValueI("OriginalImage");
	AssignImage();
	// Calculate zoom
	CRect clRect;
	m_ctrlPicture.GetClientRect(clRect);
	int iObjWidth=pInfo->Rect.Width();
	int iObjHeight=pInfo->Rect.Height();
	if(iObjHeight>iObjWidth)
	{
		m_fZoom=(float)(iObjHeight)*ZOOM_MULTIPLIER/clRect.bottom;
	}
	else
	{
		m_fZoom=(float)(iObjWidth)*ZOOM_MULTIPLIER/clRect.right;
	}
	m_yFit=false;
	m_cbFit.SetCheck(m_yFit);
	AdjustScrolls();
	// Calculate offsets and shift sliders to that position
	SCROLLINFO info;
	m_ctrlHScrl.GetScrollInfo(&info, SIF_ALL);
	info.nPos=(int)((pInfo->Rect.m_iLeft-(iObjWidth*(ZOOM_MULTIPLIER-1)/2))/m_fHScale);
	m_ctrlHScrl.SetScrollInfo(&info);
	m_ctrlVScrl.GetScrollInfo(&info, SIF_ALL);
	info.nPos=(int)((pInfo->Rect.m_iTop-((iObjHeight*(ZOOM_MULTIPLIER-1)/2)))/m_fVScale);
	m_ctrlVScrl.SetScrollInfo(&info);
	//AssignImage();
	UpdateImInfo();	
}

void CDisplayWindow::OnDisplayWindowBtnZoomReset() 
{
	m_fZoom=1;	
	AdjustScrolls();
	UpdateImInfo();
}

int CDisplayWindow::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	m_dlgInfo.Create(IDD_TEXT_INFO_DLG);
	m_dlgHistogram.Create(IDD_HISTOGRAM_DLG,this);
	return 0;
}

void CDisplayWindow::OnDisplayWindowBtnShowTransformed() 
{
	if(m_yTransformed)
	{
		m_yTransformed=false;
		AssignImage();
		m_btnShowTransformed.SetWindowText("Show transf.");
		m_btnNext.EnableWindow(true);
		m_btnPrev.EnableWindow(true);
		m_btnNextObj.EnableWindow(true);
		m_btnPrevObj.EnableWindow(true);
		m_btnCenterObj.EnableWindow(true);
		m_ctrlCBAllObj.EnableWindow(true);
	}
	else
	{
		m_yTransformed=true;
		AssignTransfomed();
		m_btnShowTransformed.SetWindowText("Back...");
		m_btnNext.EnableWindow(false);
		m_btnPrev.EnableWindow(false);
		m_btnNextObj.EnableWindow(false);
		m_btnPrevObj.EnableWindow(false);
		m_btnCenterObj.EnableWindow(false);
		m_ctrlCBAllObj.EnableWindow(false);
	}
	UpdateImInfo();
	Invalidate();
}

void CDisplayWindow::AssignTransfomed()
{
	m_DibBuffer.CreateFrom(*(m_pSpecimen->GetObjects()->GetObjectInfo(m_iCurrentObj)->GetTransformed()));
	AdjustScrolls();
}

void CDisplayWindow::OnDisplayWindowPicture() 
{
	// Select blob if there's one under the mouse!
}

void CDisplayWindow::OnLButtonUp(UINT nFlags, CPoint point) 
{
	int iMX=0;
	int iMY=0;
	if(ConvertCoordinates(point,iMX,iMY))
	{
		// Find if any object is under this point
		CSJObjectInfo* ObjInfo=NULL;
		for(int iCount=0;iCount<m_iTotalObj;iCount++)
		{
			ObjInfo=m_pSpecimen->GetObjects()->GetObjectInfo(iCount);ASSERT(ObjInfo);
			// don't draw selected object
			if(iCount==m_iCurrentObj)continue;
			// Skip the object if it's not for the current image
			if(m_iCurrentlyShownImage!=ObjInfo->GetValueI("OriginalImage"))continue;
			if(ObjInfo->Rect.PtInRect(iMX,iMY))
			{
				m_iCurrentObj=iCount-1;
				// So I don't need to repeat this routine.
				OnDisplayWindowBtnNextObj();
				break;
			}
		}
	}
	CDialog::OnLButtonUp(nFlags, point);
}

void CDisplayWindow::OnDisplayWindowBtnHist() 
{
	CChooseHistogramDlg aDlg(this);
	if(aDlg.DoModal()==IDOK)
	{
		m_strSelectedHist=aDlg.m_strSelected;
		if(m_strSelectedHist!="")ShowHistogram();
	}
}

void CDisplayWindow::ShowHistogram()
{
	m_dlgHistogram.SetWindowText(m_strSelectedHist);
	if(m_strSelectedHist=="Image Histogram")
	{
		m_yImHist=true;
		if(!m_yTemp) m_dlgHistogram.MakeHistogram(*m_pSpecimen->GetImageList()->GetImage(m_iCurrentlyShownImage));
		else m_dlgHistogram.MakeHistogram(*m_pSpecimen->GetTempImages()->GetImage(m_iCurrentlyShownImage));
		m_dlgHistogram.ShowWindow(true);
		return;
	}
	else
		m_yImHist=false;
	m_dlgHistogram.MakeHistogram(*m_pSpecimen->GetObjects(),m_strSelectedHist);
	m_dlgHistogram.ShowWindow(true);
}

void CDisplayWindow::FillListForHist(CChooseHistogramDlg *pDlg)
{
	ASSERT(pDlg);
	pDlg->AddString("Image Histogram");
	// Find features in the object information which could be represented as histogram
	strIMapType pHistList;
	for(int iCount=0;iCount<m_iTotalObj;iCount++)
	{
		CSJObjectInfo* ObjInfo=m_pSpecimen->GetObjects()->GetObjectInfo(iCount);ASSERT(ObjInfo);
		for(int i=0;i<ObjInfo->GetNumVars();i++)
		{
			// Check if the value isn't a number
			double dVal=atof(ObjInfo->GetValueAt(i).data());
			// If it's not a number the sum will be 0
			pHistList[ObjInfo->GetNameAt(i)]+=(int)ceil(fabs(dVal));
		}
	}
	if(pHistList.empty())return;
	for(strIMapIterator pos=pHistList.begin();pos!=pHistList.end();++pos)
		if(pos->second!=0)pDlg->AddString((pos->first).data());
}

void CDisplayWindow::ApplyHistRegions(bool yApply/*=true*/)
{
	if(yApply)
	{
		m_dRight=m_dlgHistogram.GetRight();
		m_dLeft=m_dlgHistogram.GetLeft();
		if(m_yImHist)
		{
			CSJImage Im(*m_pSpecimen->GetImageList()->GetImage(m_iCurrentlyShownImage));
			Im.ClipColors(CSJRGBAColor((WORD)m_dLeft),CSJRGBAColor((WORD)m_dRight),CSJRGBAColor((WORD)0x00));
			m_DibBuffer.CreateFrom(Im);
			AdjustScrolls();
			return;
		}
	}
	else
	{
		m_dRight=0;
		m_dLeft=0;
		// Restore default image
		AssignImage();
	}
}

void CDisplayWindow::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	int iMX=0;
	int iMY=0;
	if(ConvertCoordinates(point,iMX,iMY))
	{
		// Add remove or something here!
		// Go through the all markers
		bool yAddFlag=true;
		for(Marker_vector_type_iter pos=m_Markers.begin();pos!=m_Markers.end();++pos)
			if(pos->VeryClose(iMX,iMY))
			{
				if(pos->GetType()==MARKER_SUBSTRUCT)
				{
					pos=m_Markers.erase(pos);
					UpdateImInfo();
				}
				yAddFlag=false;
				break;
			}
		if(yAddFlag)
		{
			m_Markers.push_back(CSJMarker(iMX,iMY,MARKER_ADD));
			UpdateImInfo();
		}
	}
	CDialog::OnLButtonDblClk(nFlags, point);
}

// Add substract marker
void CDisplayWindow::OnRButtonDblClk(UINT nFlags, CPoint point) 
{
	int iMX=0;
	int iMY=0;
	if(ConvertCoordinates(point,iMX,iMY))
	{
		// Add remove or something here!
		// Go through the all markers
		bool yAddFlag=true;
		for(Marker_vector_type_iter pos=m_Markers.begin();pos!=m_Markers.end();++pos)
			if(pos->VeryClose(iMX,iMY))
			{
				if(pos->GetType()==MARKER_ADD)
				{
					pos=m_Markers.erase(pos);
					UpdateImInfo();
				}
				yAddFlag=false;
				break;
			}
		if(yAddFlag)
		{
			m_Markers.push_back(CSJMarker(iMX,iMY,MARKER_SUBSTRUCT));
			UpdateImInfo();
		}
	}
	CDialog::OnRButtonDblClk(nFlags, point);
}

bool CDisplayWindow::ConvertCoordinates(CPoint point, int &iMX, int &iMY)
{
	// Select blob if there's one under the mouse!
	CRect tRect;
	// Make screen coordinates
	m_ctrlPicture.GetClientRect(tRect);
	ClientToScreen(&point);
	m_ctrlPicture.ScreenToClient(&point);
	if(tRect.PtInRect(point))
	{
		// Coordinates for image
		iMX=point.x;
		iMY=point.y;
		// Now account for zoom and fit
		float	fScaleX = 1,
				fScaleY = 1;
		int		iShiftX=0,
				iShiftY=0;
		CRect clRect;
		m_ctrlPicture.GetClientRect(clRect);
		if(m_yFit)
		{
			fScaleX = (float)clRect.right/m_DibBuffer.GetWidth();
			fScaleY = (float)clRect.bottom/m_DibBuffer.GetHeight();
		}
		else
		{
			fScaleX=1/m_fZoom;
			fScaleY=1/m_fZoom;
			SCROLLINFO info;
			// Image is larger then the rect of drawing
			if(m_ctrlHScrl.IsWindowVisible())
			{
				m_ctrlHScrl.GetScrollInfo(&info, SIF_ALL);
				iShiftX=(int)(info.nTrackPos*m_fHScale);
			}
			if(m_ctrlVScrl.IsWindowVisible())
			{
				m_ctrlVScrl.GetScrollInfo(&info, SIF_ALL);
				iShiftY=(int)(info.nTrackPos*m_fVScale);
			}
		}
		iMX=(int)(iMX/fScaleX)+iShiftX;
		iMY=(int)(iMY/fScaleY)+iShiftY;
		return true;
	}
	return false;
}

void CDisplayWindow::OnDisplayWindowBtnDelMarkers() 
{
	m_Markers.clear();	
	UpdateImInfo();
}

void CDisplayWindow::OnDisplayWindowCbTempImages() 
{
	if(m_ctrlCBTemp.GetCheck()==1)
	{
		m_yTemp=true;
		if(m_iCurrentlyShownImage>=m_pSpecimen->GetTempImages()->GetLength())
			m_iCurrentlyShownImage=m_pSpecimen->GetTempImages()->GetLength()-1;
	}
	else
	{
		m_yTemp=false;
		if(m_iCurrentlyShownImage>=m_pSpecimen->GetImageList()->GetLength())
			m_iCurrentlyShownImage=m_pSpecimen->GetImageList()->GetLength()-1;
	}
	AssignImage();
	UpdateImInfo();
}

void CDisplayWindow::OnOK() 
{
	//SaveMarked();
	MarkObjects();
	CDialog::OnOK();
}

void CDisplayWindow::SaveMarked()
{
	std::ofstream fOut;
	// If file doesn't exist it will be created
	fOut.open("save.dat",std::ios::app);
	for(int iCount=0;iCount<m_iTotalObj;iCount++)
	{
		CSJObjectInfo *ObjInfo=NULL;
		// don't draw selected object
		ObjInfo=m_pSpecimen->GetObjects()->GetObjectInfo(iCount);
		// Go through all markers
		for(Marker_vector_type::iterator pos=m_Markers.begin();pos!=m_Markers.end();++pos)
		{
			if(ObjInfo->Rect.PtInRect(pos->GetX(),pos->GetY()))
			{
				// Save data from this object
				//ObjNumber first
				fOut<<ObjInfo->GetValue("DB: Area")
					<<ObjInfo->GetValue("DB: dDistinctness")
					<<ObjInfo->GetValue("DB: dEntropy")
					<<ObjInfo->GetValue("DB: dRMax")
					<<ObjInfo->GetValue("DB: dRoundness");
//				fOut<<std::setw(10)<<iCount+1
//					<<std::setw(10)<<ObjInfo->GetValue("CenterX")
//					<<std::setw(10)<<ObjInfo->GetValue("CenterY")
//					<<std::setw(10)<<ObjInfo->GetValue("Area")
//					<<std::setw(10)<<ObjInfo->GetValue("dDistinctness")
//					<<std::setw(10)<<ObjInfo->GetValue("dEntropy")
//					<<std::setw(10)<<ObjInfo->GetValue("dRMax")
//					<<std::setw(10)<<ObjInfo->GetValue("dRoundness")<<std::endl;
					//<<std::setw(10)<<ObjInfo->GetValue("");
				break;
			}
		}
	}
	fOut.close();
}

void CDisplayWindow::MarkObjects()
{
	for(int iCount=0;iCount<m_iTotalObj;iCount++)
	{
		CSJObjectInfo *ObjInfo=NULL;
		// don't draw selected object
		ObjInfo=m_pSpecimen->GetObjects()->GetObjectInfo(iCount);
		// Go through all markers
		for(Marker_vector_type::iterator pos=m_Markers.begin();pos!=m_Markers.end();++pos)
			if(ObjInfo->Rect.PtInRect(pos->GetX(),pos->GetY()))
			{
				ObjInfo->SetValue("Marked",1);
				break;
			}
	}
}
