// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
#if !defined(AFX_HISTOGRAMDLG_H__B5717191_A894_4D0D_8855_98BB0F5E0323__INCLUDED_)
#define AFX_HISTOGRAMDLG_H__B5717191_A894_4D0D_8855_98BB0F5E0323__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#pragma warning(disable:4786)
#include <map>
#include <algorithm>

#include "DibBuffer.h"
#include "../../../Interfaces/Interfaces_def.h"

#define HIST_WIDTH 256
#define HIST_HEIGHT 100

class CHistogramDlg : public CDialog
{
	enum eMarkers {LEFT_MARKER,RIGHT_MARKER};
// Construction
public:
	void UpdateMarker(int iM,double dPos);
	bool ConverMousePos(CPoint point,double &dX, double &dY);
	void UpdateInfo();
	void MakeHistogram(CSJImage &Im);
	void MakeHistogram(CSJObjectInfoList &objList,CString strFeature);
	void UpdateDib();
	double GetRight(){return m_dRight;};
	double GetLeft(){return m_dLeft;};
	CHistogramDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CHistogramDlg)
	enum { IDD = IDD_HISTOGRAM_DLG };
	CButton	m_ctrlCBLog;
	CEdit	m_ctrlEditRS;
	CEdit	m_ctrlEditLS;
	CComboBox	m_ctrlLBNV;
	CStatic	m_ctrlPicture;
	CStatic	m_ctrlStaticCursorPos;
	CStatic	m_ctrlStaticXMin;
	CStatic	m_ctrlStaticYMax;
	CStatic	m_ctrlStaticYMin;
	CStatic	m_ctrlStaticXMax;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHistogramDlg)
	public:
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void CreateImageHistogram();
	typedef std::map<double,double> DMapType;
	DMapType		m_Hist;
	DMapType		m_NormXHist;
	CDibBuffer		m_DibBuffer;
	UINT			m_uTimerID;
	double			m_dXMin;
	double			m_dXMax;
	double			m_dYMax;
	double			m_dYMin;
	double			m_dXScale;
	double			m_dYScale;
	double			m_dRight;
	double			m_dLeft;
	bool			m_yLogScale;
	int				m_iDrawLeftMarker;
	int				m_iDrawRightMarker;
	int				m_iMarkerHeight;
	void ShowMarkers(CDC* cDc);
	// Generated message map functions
	//{{AFX_MSG(CHistogramDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnHistogramDlgCbLog();
	afx_msg void OnHistogramDlgBtnUpdate();
	afx_msg void OnKillfocusHistogramDlgEditLeftSelection();
	afx_msg void OnKillfocusHistogramDlgEditRightSelection();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HISTOGRAMDLG_H__B5717191_A894_4D0D_8855_98BB0F5E0323__INCLUDED_)
