// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
//$Header: c:\\users\\sj\\CVS/Thesis/PlugIns/DISPLAY/SimpleDisplay/SimpleDisplay.cpp,v 1.5 2002/05/27 22:29:35 sj Exp $
// SimpleDisplay.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include <afxdllx.h>
#include "resource.h"
#include "DisplayWindow.h"

#define DISPLAY_SECTION "SimpleDisplay"
#define FIT_VNAME "Fit"
#define SHOW_ALL_VNAME "ShowAll"

static AFX_EXTENSION_MODULE SimpleDisplayDLL = { NULL, NULL };

// Display Window
EXPORT_VAR_MACRO CDisplayWindow DispWnd;

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("SIMPLEDISPLAY.DLL Initializing!\n");
		
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(SimpleDisplayDLL, hInstance))
			return 0;

		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

		new CDynLinkLibrary(SimpleDisplayDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("SIMPLEDISPLAY.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(SimpleDisplayDLL);
	}
	return 1;   // ok
}

EXPORT_FNT_MARCO int GetType()
{
	return SJ_PLGUIN_TYPE_DISPLAY;
}

EXPORT_FNT_MARCO int GetInfo(std::string& Info)
{
#ifdef _DEBUG
	Info="SimpleDisplay ($Revision: 1.5 $)(Debug)";
#else
	Info="SimpleDisplay ($Revision: 1.5 $)";
#endif
	return SJ_MFC_DIALOG_SETUP;
}

EXPORT_FNT_MARCO int SetupDll(const char *iniName)
{
	// No setup for this PlugIn
	return 1;
}

// Initializes whatever you need for work. Should be called once, or in pair with Done
EXPORT_FNT_MARCO int Init(CSJSpecimen &Specimen)
{
	if(Specimen.GetIniFile()->GetValueI(DISPLAY_SECTION,FIT_VNAME)==1) 
		DispWnd.SetFit(true);
	else
		DispWnd.SetFit(false);
	if(Specimen.GetIniFile()->GetValueI(DISPLAY_SECTION,SHOW_ALL_VNAME)==1)
		DispWnd.SetShowAllObj(true);
	else
		DispWnd.SetShowAllObj(false);
	return 1;
}

// Shuts down hardware or whatever you need to do here. Cleaning and so on...
EXPORT_FNT_MARCO int Done(CSJSpecimen &Specimen)
{
	return 1;
}

// Displays data from Specimen
EXPORT_FNT_MARCO int Display(CSJSpecimen &Specimen)
{
	if(Specimen.GetImageList()->GetLength()==0)return 1;
	DispWnd.AssignSpecimen(&Specimen);
	if(DispWnd.DoModal()==IDOK)
	{
		Specimen.GetIniFile()->SetValueI(DISPLAY_SECTION,FIT_VNAME,DispWnd.IsFit());
		Specimen.GetIniFile()->SetValueI(DISPLAY_SECTION,SHOW_ALL_VNAME,DispWnd.IsShowAllObj());
		Specimen.GetIniFile()->WriteFile();
		return 1;
	}
	return 0;	
}

// Initializes environment for the research mode
EXPORT_FNT_MARCO int ResearchInit(CSJSpecimen &Specimen)
{
	return Init(Specimen);
}

// Shuts down hardware or whatever you need to do here. Cleaning and so on...
EXPORT_FNT_MARCO int DispResearchDone(CSJSpecimen &Specimen)
{
	return Done(Specimen);
}

// Displays data from Specimen
EXPORT_FNT_MARCO int Update(CSJSpecimen &Specimen)
{
	return Display(Specimen);
}
