// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
// TextInfoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TextInfoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTextInfoDlg dialog


CTextInfoDlg::CTextInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTextInfoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTextInfoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_pSpecimen=NULL;
}


void CTextInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTextInfoDlg)
	DDX_Control(pDX, IDC_TEXT_INFO_LB, m_ctrlLBInfo);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTextInfoDlg, CDialog)
	//{{AFX_MSG_MAP(CTextInfoDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTextInfoDlg message handlers

BOOL CTextInfoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	if(m_pSpecimen)
	{
		m_ctrlLBInfo.AddString("Vars:");
		for(int i=0;i<m_pSpecimen->GetVars()->GetNumVars();i++)
		{
			std::string strHelp=m_pSpecimen->GetVars()->GetNameAt(i)+"="+m_pSpecimen->GetVars()->GetValueAt(i);
			m_ctrlLBInfo.AddString(strHelp.data());
		}
		m_ctrlLBInfo.AddString("------");
		m_ctrlLBInfo.AddString("Object Info:");
		CString strHelp;
		for(i=0;i<m_pSpecimen->GetObjects()->GetLength();i++)
		{
			CSJObjectInfo* pInf=NULL;
			pInf=m_pSpecimen->GetObjects()->GetObjectInfo(i);
			strHelp.Format("-- Object #%d",i+1);
			m_ctrlLBInfo.AddString("");
			m_ctrlLBInfo.AddString(strHelp);
			strHelp.Format(	"Left=%d,Top=%d,Right=%d,Bottom=%d",
							pInf->Rect.m_iLeft,
							pInf->Rect.m_iTop,
							pInf->Rect.m_iRight,
							pInf->Rect.m_iBottom);
			m_ctrlLBInfo.AddString(strHelp);
			strHelp.Format(	"Width=%d,Height=%d",
							pInf->Rect.Width(),
							pInf->Rect.Height());
			m_ctrlLBInfo.AddString(strHelp);
			for(int j=0;j<pInf->GetNumVars();j++)
			{
				std::string strHelp=pInf->GetNameAt(j)+"="+pInf->GetValueAt(j);
				m_ctrlLBInfo.AddString(strHelp.data());
			}
		}
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

