// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
// SOMDBSetupDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SOMDBSetupDlg.h"
#include "FolderDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSOMDBSetupDlg dialog


CSOMDBSetupDlg::CSOMDBSetupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSOMDBSetupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSOMDBSetupDlg)
	//}}AFX_DATA_INIT
}


void CSOMDBSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSOMDBSetupDlg)
	DDX_Control(pDX, IDC_SOMDB_SETUP_DLG_EDIT_RLEN2, m_ctrlEditRlen2);
	DDX_Control(pDX, IDC_SOMDB_SETUP_DLG_EDIT_RLEN1, m_ctrlEditRlen1);
	DDX_Control(pDX, IDC_SOMDB_SETUP_DLG_EDIT_RADIUS2, m_ctrlEditRadius2);
	DDX_Control(pDX, IDC_SOMDB_SETUP_DLG_EDIT_RADIUS1, m_ctrlEditRadius1);
	DDX_Control(pDX, IDC_SOMDB_SETUP_DLG_EDIT_ALPHA2, m_ctrlEditAlpha2);
	DDX_Control(pDX, IDC_SOMDB_SETUP_DLG_EDIT_ALPHA1, m_ctrlEditAlpha1);
	DDX_Control(pDX, IDC_SOMDB_SETUP_CB_COLLECT, m_ctrlCBCollect);
	DDX_Control(pDX, IDC_SOMDB_SETUP_DLG_EDIT_NODE_Y, m_ctrlEditY);
	DDX_Control(pDX, IDC_SOMDB_SETUP_DLG_EDIT_NODE_X, m_ctrlEditX);
	DDX_Control(pDX, IDC_SOMDB_SETUP_DLG_EDIT_USER_IN, m_ctrlEditUseIn);
	DDX_Control(pDX, IDC_SOMDB_SETUP_DLG_EDIT_SOM_PAK, m_ctrlEditSomPakPath);
	DDX_Control(pDX, IDC_SOMDB_SETUP_DLG_LB_PARAMS, m_ctrlLBParams);
	DDX_Control(pDX, IDC_SOMDB_SETUP_DLG_LB_LABELS, m_ctrlLBLabels);
	DDX_Control(pDX, IDC_SOMDB_SETUP_DLG_EDIT_PARAM, m_ctrlEditParam);
	DDX_Control(pDX, IDC_SOMDB_SETUP_DLG_EDIT_MAP, m_ctrlEditMap);
	DDX_Control(pDX, IDC_SOMDB_SETUP_DLG_EDIT_LABEL, m_ctrlEditLabel);
	DDX_Control(pDX, IDC_SOMDB_SETUP_DLG_COMBO_TOPOLOGY, m_ctrlComboTopol);
	DDX_Control(pDX, IDC_SOMDB_SETUP_DLG_COMBO_NEIGH, m_ctrlComboNeigh);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSOMDBSetupDlg, CDialog)
	//{{AFX_MSG_MAP(CSOMDBSetupDlg)
	ON_BN_CLICKED(IDC_SOMDB_SETUP_DLG_BTN_SOM_PAK_BROWSE, OnSomdbSetupDlgBtnSomPakBrowse)
	ON_BN_CLICKED(IDC_SOMDB_SETUP_DLG_BTN_MAP_BROWSE, OnSomdbSetupDlgBtnMapBrowse)
	ON_BN_CLICKED(IDC_SOMDB_SETUP_DLG_BTN_USER_IN_BROWSE, OnSomdbSetupDlgBtnUserInBrowse)
	ON_BN_CLICKED(IDC_SOMDB_SETUP_DLG_BTN_ADD_PARAM, OnSomdbSetupDlgBtnAddParam)
	ON_BN_CLICKED(IDC_SOMDB_SETUP_DLG_BTN_REMOVE_PARAM, OnSomdbSetupDlgBtnRemoveParam)
	ON_BN_CLICKED(IDC_SOMDB_SETUP_DLG_BTN_LABEL_ADD, OnSomdbSetupDlgBtnLabelAdd)
	ON_BN_CLICKED(IDC_SOMDB_SETUP_DLG_BTN_LABEL_REMOVE, OnSomdbSetupDlgBtnLabelRemove)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSOMDBSetupDlg message handlers

BOOL CSOMDBSetupDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_Ini.SetPath(m_strIniFN);
	m_Ini.ReadFile();
	// Load all variables here;
	m_ctrlEditSomPakPath.SetWindowText(m_Ini.GetValue(SOMDB_INI_SECTION,SOMDB_SOM_PAK_DIR).data());
	m_ctrlEditMap.SetWindowText(m_Ini.GetValue(SOMDB_INI_SECTION,SOMDB_PAK_MAP).data());
	m_ctrlEditUseIn.SetWindowText(m_Ini.GetValue(SOMDB_INI_SECTION,SOMDB_USER_IN).data());
	m_ctrlEditX.SetWindowText(m_Ini.GetValue(SOMDB_INI_SECTION,SOMDB_NODE_X).data());
	m_ctrlEditY.SetWindowText(m_Ini.GetValue(SOMDB_INI_SECTION,SOMDB_NODE_Y).data());
	
	m_ctrlEditAlpha1.SetWindowText(m_Ini.GetValue(SOMDB_INI_SECTION,SOMDB_ALPHA1).data());
	m_ctrlEditAlpha2.SetWindowText(m_Ini.GetValue(SOMDB_INI_SECTION,SOMDB_ALPHA2).data());
	m_ctrlEditRadius1.SetWindowText(m_Ini.GetValue(SOMDB_INI_SECTION,SOMDB_RADIUS1).data());
	m_ctrlEditRadius2.SetWindowText(m_Ini.GetValue(SOMDB_INI_SECTION,SOMDB_RADIUS2).data());
	m_ctrlEditRlen1.SetWindowText(m_Ini.GetValue(SOMDB_INI_SECTION,SOMDB_RLEN1).data());
	m_ctrlEditRlen2.SetWindowText(m_Ini.GetValue(SOMDB_INI_SECTION,SOMDB_RLEN2).data());

	m_ctrlCBCollect.SetCheck(m_Ini.GetValueI(SOMDB_INI_SECTION,SOMDB_COLLECT));

	int iIndex=m_ctrlComboNeigh.FindStringExact(-1,m_Ini.GetValue(SOMDB_INI_SECTION,SOMDB_NEIGH).data());
	if(iIndex==CB_ERR)iIndex=0;
	m_ctrlComboNeigh.SetCurSel(iIndex);
	iIndex=m_ctrlComboNeigh.FindStringExact(-1,m_Ini.GetValue(SOMDB_INI_SECTION,SOMDB_TOPOL).data());
	if(iIndex==CB_ERR)iIndex=0;
	m_ctrlComboTopol.SetCurSel(iIndex);
	
	// Fill list of parameters
	int iCount=0;
	while(m_Ini.HaveVariable(SOMDB_INI_SECTION,Format("P%d",iCount)))
	{
		m_ctrlLBParams.AddString(m_Ini.GetValue(SOMDB_INI_SECTION,Format("P%d",iCount)).data());
		iCount++;
	}
	// Fill list of labels
	iCount=0;
	while(m_Ini.HaveVariable(SOMDB_INI_SECTION,Format("L%d",iCount)))
	{
		m_ctrlLBLabels.AddString(m_Ini.GetValue(SOMDB_INI_SECTION,Format("L%d",iCount)).data());
		iCount++;
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSOMDBSetupDlg::OnOK() 
{
	std::string sT=m_Ini.GetPath();
	m_Ini.Reset();
	m_Ini.SetPath(sT);
	// Check data here
	if(atoi(GetStr(m_ctrlEditX).data())==0 || atoi(GetStr(m_ctrlEditY).data())==0)
	{
		MessageBox("Number of nodes is incorrect");
		return;
	}
	// Save data here.
	m_Ini.SetValue(SOMDB_INI_SECTION,SOMDB_SOM_PAK_DIR,GetStr(m_ctrlEditSomPakPath));
	m_Ini.SetValue(SOMDB_INI_SECTION,SOMDB_PAK_MAP,GetStr(m_ctrlEditMap));
	m_Ini.SetValue(SOMDB_INI_SECTION,SOMDB_USER_IN,GetStr(m_ctrlEditUseIn));
	m_Ini.SetValue(SOMDB_INI_SECTION,SOMDB_NODE_X,GetStr(m_ctrlEditX));
	m_Ini.SetValue(SOMDB_INI_SECTION,SOMDB_NODE_Y,GetStr(m_ctrlEditY));
	
	m_Ini.SetValue(SOMDB_INI_SECTION,SOMDB_ALPHA1,GetStr(m_ctrlEditAlpha1));
	m_Ini.SetValue(SOMDB_INI_SECTION,SOMDB_ALPHA2,GetStr(m_ctrlEditAlpha2));
	m_Ini.SetValue(SOMDB_INI_SECTION,SOMDB_RADIUS1,GetStr(m_ctrlEditRadius1));
	m_Ini.SetValue(SOMDB_INI_SECTION,SOMDB_RADIUS2,GetStr(m_ctrlEditRadius2));
	m_Ini.SetValue(SOMDB_INI_SECTION,SOMDB_RLEN1,GetStr(m_ctrlEditRlen1));
	m_Ini.SetValue(SOMDB_INI_SECTION,SOMDB_RLEN2,GetStr(m_ctrlEditRlen2));

	// Now get values out of Combo boxes
	m_Ini.SetValue(SOMDB_INI_SECTION,SOMDB_NEIGH,GetStr(m_ctrlComboNeigh));
	m_Ini.SetValue(SOMDB_INI_SECTION,SOMDB_TOPOL,GetStr(m_ctrlComboTopol));
	m_Ini.SetValueI(SOMDB_INI_SECTION,SOMDB_COLLECT,m_ctrlCBCollect.GetCheck());
	// Save params
	for(int i=0;i<m_ctrlLBParams.GetCount();i++)
	{
		CString str;
		m_ctrlLBParams.GetText(i,str);
		if(str=="")break;
		m_Ini.SetValue(SOMDB_INI_SECTION,Format("P%d",i),str.GetBuffer(str.GetLength()));
	}
	// Save labels
	for(i=0;i<m_ctrlLBLabels.GetCount();i++)
	{
		CString str;
		m_ctrlLBLabels.GetText(i,str);
		if(str=="")break;
		m_Ini.SetValue(SOMDB_INI_SECTION,Format("L%d",i),str.GetBuffer(str.GetLength()));
	}
	m_Ini.WriteFile();
	CDialog::OnOK();
}

std::string CSOMDBSetupDlg::GetStr(CEdit &ctrl)
{
	CString cstr;
	std::string str;
	ctrl.GetWindowText(cstr);
	str=cstr.GetBuffer(cstr.GetLength());
	return str;
}

std::string CSOMDBSetupDlg::GetStr(CComboBox &ctrl)
{
	CString cstr;
	std::string str;
	ctrl.GetWindowText(cstr);
	str=cstr.GetBuffer(cstr.GetLength());
	return str;
}


void CSOMDBSetupDlg::OnSomdbSetupDlgBtnSomPakBrowse() 
{
	// Show the directory structure here
	CFolderDialog dlg(_T("SOMDB Setup choose SOM-PAK directory"),GetStr(m_ctrlEditSomPakPath).data(), this);
	if(dlg.DoModal() == IDOK)
		m_ctrlEditSomPakPath.SetWindowText(dlg.GetFolderPath());
}

void CSOMDBSetupDlg::OnSomdbSetupDlgBtnMapBrowse() 
{
	CFileDialog openDlg(true, "*.cod", GetStr(m_ctrlEditMap).data(), OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
						"Map files(*.cod)|*.cod|All Files (*.*)|*.*|");
	if (openDlg.DoModal() == IDOK)
		m_ctrlEditMap.SetWindowText(openDlg.GetPathName());	
}

void CSOMDBSetupDlg::OnSomdbSetupDlgBtnUserInBrowse() 
{
	CFileDialog openDlg(true, "*.inp", GetStr(m_ctrlEditUseIn).data(), OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
						"Map files(*.inp)|*.inp|All Files (*.*)|*.*|");
	if (openDlg.DoModal() == IDOK)
		m_ctrlEditUseIn.SetWindowText(openDlg.GetPathName());
}

void CSOMDBSetupDlg::OnSomdbSetupDlgBtnAddParam() 
{
	m_ctrlLBParams.AddString(GetStr(m_ctrlEditParam).data());
	m_ctrlEditParam.SetWindowText("");
}

void CSOMDBSetupDlg::OnSomdbSetupDlgBtnRemoveParam() 
{
	int iC=m_ctrlLBParams.GetCurSel();
	if(iC==LB_ERR)return;
	m_ctrlLBParams.DeleteString(iC);
}

void CSOMDBSetupDlg::OnSomdbSetupDlgBtnLabelAdd() 
{
	m_ctrlLBLabels.AddString(GetStr(m_ctrlEditLabel).data());
	m_ctrlEditLabel.SetWindowText("");
}

void CSOMDBSetupDlg::OnSomdbSetupDlgBtnLabelRemove() 
{
	int iC=m_ctrlLBLabels.GetCurSel();
	if(iC==LB_ERR)return;
	m_ctrlLBLabels.DeleteString(iC);
}
