// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
#if !defined(AFX_SOMDBSETUPDLG_H__A8469F1A_0D2F_4A5B_BEA9_0C8D6FD8073A__INCLUDED_)
#define AFX_SOMDBSETUPDLG_H__A8469F1A_0D2F_4A5B_BEA9_0C8D6FD8073A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SOMDBSetupDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSOMDBSetupDlg dialog
#include "resource.h"
#include "../../../Interfaces/Interfaces_def.h"

// If you want to store preferences in the global Ini file
// It's convinuent to use such definitions
#define SOMDB_INI_SECTION "SOMDB_CONFIG"
#define SOMDB_SOM_PAK_DIR "SOM_PAK_DIR"
#define SOMDB_PAK_MAP "SOMDB_PAK_MAP"
#define SOMDB_USER_IN "SOMDB_USER_IN"
#define SOMDB_NODE_X "SOMDB_NODE_X"
#define SOMDB_NODE_Y "SOMDB_NODE_Y"
#define SOMDB_NEIGH "SOMDB_NEIGH"
#define SOMDB_TOPOL "SOMDB_TOPOL"
#define SOMDB_COLLECT "SOMDB_COLLECT"
#define SOMDB_ALPHA1 "SOMDB_ALPHA1"
#define SOMDB_ALPHA2 "SOMDB_ALPHA2"
#define SOMDB_RADIUS1 "SOMDB_RADIUS1"
#define SOMDB_RADIUS2 "SOMDB_RADIUS2"
#define SOMDB_RLEN1 "SOMDB_RLEN1"
#define SOMDB_RLEN2 "SOMDB_RLEN2"


#define SOMDB_PARAM_FN "SOMDB_PARAM_FN"

class CSOMDBSetupDlg : public CDialog
{
// Construction
public:
	std::string GetStr(CEdit& ctrl);
	std::string GetStr(CComboBox& ctrl);
	CSOMDBSetupDlg(CWnd* pParent = NULL);   // standard constructor
	std::string m_strIniFN;
// Dialog Data
	//{{AFX_DATA(CSOMDBSetupDlg)
	enum { IDD = IDD_SOMDB_SETUP_DLG };
	CEdit	m_ctrlEditRlen2;
	CEdit	m_ctrlEditRlen1;
	CEdit	m_ctrlEditRadius2;
	CEdit	m_ctrlEditRadius1;
	CEdit	m_ctrlEditAlpha2;
	CEdit	m_ctrlEditAlpha1;
	CButton	m_ctrlCBCollect;
	CEdit	m_ctrlEditY;
	CEdit	m_ctrlEditX;
	CEdit	m_ctrlEditUseIn;
	CEdit	m_ctrlEditSomPakPath;
	CListBox	m_ctrlLBParams;
	CListBox	m_ctrlLBLabels;
	CEdit	m_ctrlEditParam;
	CEdit	m_ctrlEditMap;
	CEdit	m_ctrlEditLabel;
	CComboBox	m_ctrlComboTopol;
	CComboBox	m_ctrlComboNeigh;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSOMDBSetupDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CSJIniFile m_Ini;
	// Generated message map functions
	//{{AFX_MSG(CSOMDBSetupDlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnSomdbSetupDlgBtnSomPakBrowse();
	afx_msg void OnSomdbSetupDlgBtnMapBrowse();
	afx_msg void OnSomdbSetupDlgBtnUserInBrowse();
	afx_msg void OnSomdbSetupDlgBtnAddParam();
	afx_msg void OnSomdbSetupDlgBtnRemoveParam();
	afx_msg void OnSomdbSetupDlgBtnLabelAdd();
	afx_msg void OnSomdbSetupDlgBtnLabelRemove();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SOMDBSETUPDLG_H__A8469F1A_0D2F_4A5B_BEA9_0C8D6FD8073A__INCLUDED_)
