// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
//$Header: c:\\users\\sj\\CVS/Thesis/PlugIns/DataBase/SimpleRejector/SimpleRejector.cpp,v 1.8 2002/05/27 22:29:35 sj Exp $
// SimpleRejector.cpp : Defines the initialization routines for the DLL.
//

#include <afxdllx.h>
#include <string>
#include "stdafx.h"

#include "../../../Interfaces/Interfaces_def.h"
#include "AskMinAreaDlg.h"

static AFX_EXTENSION_MODULE SimpleRejectorDLL = { NULL, NULL };

extern "C" int APIENTRY DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{UNREFERENCED_PARAMETER(lpReserved);if (dwReason == DLL_PROCESS_ATTACH){TRACE0("SIMPLEREJECTOR.DLL Initializing!\n");
if (!AfxInitExtensionModule(SimpleRejectorDLL, hInstance))return 0;new CDynLinkLibrary(SimpleRejectorDLL);}else if(dwReason==DLL_PROCESS_DETACH){
TRACE0("SIMPLEREJECTOR.DLL Terminating!\n");AfxTermExtensionModule(SimpleRejectorDLL);}return 1;}

EXPORT_FNT_MARCO int GetType()
{
	return SJ_PLGUIN_TYPE_DATABASE;
}

EXPORT_FNT_MARCO int GetInfo(std::string& Info)
{
#ifdef _DEBUG
	Info="Rejecter and Stat ($Revision: 1.8 $) (Debug)";
#else
	Info="Rejecter and Stat ($Revision: 1.8 $)";
#endif	
	return SJ_MFC_DIALOG_SETUP;
}

#define INI_KEY "SimpleRejector"
#define INI_VALUENAME_MINAREA "MinArea"

EXPORT_FNT_MARCO int SetupDll(const char *iniName)
{
	// Check that we have alocated memory for the name
	if(!iniName)return 0;
	// FileName of the description INI file with information about images to be loaded from the disk
	CSJIniFile IniConfig;

	std::string strIniFN=iniName;

	IniConfig.SetPath(strIniFN);
	IniConfig.ReadFile();
	
	int iArea=IniConfig.GetValueI(INI_KEY,INI_VALUENAME_MINAREA);
	
	CAskMinAreaDlg SetupDlg;
	SetupDlg.m_iArea=iArea;
	if(SetupDlg.DoModal()==IDOK)
	{
		IniConfig.SetValueI(INI_KEY,INI_VALUENAME_MINAREA,SetupDlg.m_iArea);
		IniConfig.WriteFile();
		return 1;
	}
	return 0;
}

// Initializes whatever you need for work. Should be called once, or in pair with Done
EXPORT_FNT_MARCO int Init(CSJSpecimen &Specimen)
{
	Specimen.GetVars()->SetValue(INI_VALUENAME_MINAREA,Specimen.GetIniFile()->GetValueI(INI_KEY,INI_VALUENAME_MINAREA));
	return 1;
}

// Shuts down hardware or whatever you need to do here. Cleaning and so on...
EXPORT_FNT_MARCO int Done(CSJSpecimen &Specimen)
{
	return 1;
}

// Make a decision about each object
EXPORT_FNT_MARCO int Analyze(CSJSpecimen &Specimen)
{
	int iArea=Specimen.GetVars()->GetValueI(INI_VALUENAME_MINAREA);
	long lTotalArea=0;
	for(int iObjNum=0;iObjNum<Specimen.GetObjects()->GetLength();iObjNum++)
	{
		CSJObjectInfo *ObjInfo=NULL;
		ObjInfo=Specimen.GetObjects()->GetObjectInfo(iObjNum);
		// This plugIn require an area to be calculated!!!
		if(ObjInfo->HaveValue("Area"))
		{
			if(iArea!=0 && iArea>ObjInfo->GetValueI("Area"))
			{
				//Specimen.GetObjects()->Delete(iNum);
				ObjInfo->SetValue("Deleted",1);
			}
			else
				lTotalArea+=ObjInfo->GetValueI("Area");
		}
		else
		{
			UINT res=MessageBox(NULL,"Need plugin for area calculations","Warning",MB_ABORTRETRYIGNORE|MB_ICONWARNING);
			if(res=IDABORT)return 0;
			else continue;
		}
		if(Specimen.IsAborted())break;
	}
	if(Specimen.IsAborted())return 0;
	// Delete info about bad objects
	int iCount=0;
	while(iCount<Specimen.GetObjects()->GetLength())
		if(Specimen.GetObjects()->GetObjectInfo(iCount)->HaveValue("Deleted"))
		{
			Specimen.GetObjects()->Delete(iCount);
			iCount=0;
		}
		else iCount++;
	
	// Calculate average area (check for 0 inside)
	Specimen.GetVars()->SetValue("AvArea",iCount>0?lTotalArea/iCount:0);
	Specimen.GetVars()->SetValue("Simple Rejector",1);
	return 1;
}

