// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
//$Header$
// This's a template for Feature Plug-In.

// Create a new project with MFC AppWizard(dll)
// Choose  MFC Extension DLL (using shared MFC DLL)
// Place the contents of this file instead of automaticly created one.
// Replace AreaDivision with the name of the project
// Remove "'" from $'Revision$ in order to have correct substitution with CVS or edit it manually
// Remove "'" from $'Header$ above and remove the first line in the file!

// Add "../../../Interfaces/Interfaces.lib" to the Project Settings->Link->object/library modules
// Add "copy Debug\AreaDivision.dll ..\..\..\Amors\PlugIns\AreaDivisionD.dll"
// to the Project Settings->Post-build step

// Non zero value returned by any function means a successful finishing


#include "stdafx.h"
#include <afxdllx.h>
#include <math.h>
#include "AreaDivisionSetupDlg.h"

#include "../../../Interfaces/Interfaces_def.h"

static AFX_EXTENSION_MODULE AreaDivisionDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	UNREFERENCED_PARAMETER(lpReserved);
	if (dwReason == DLL_PROCESS_ATTACH){
		TRACE0("AreaDivision.DLL Initializing!\n");
		if (!AfxInitExtensionModule(AreaDivisionDLL, hInstance))return 0;
		new CDynLinkLibrary(AreaDivisionDLL);}
	else if (dwReason == DLL_PROCESS_DETACH){
		TRACE0("AreaDivision.DLL Terminating!\n");
		AfxTermExtensionModule(AreaDivisionDLL);}
	return 1;
}

EXPORT_FNT_MARCO int GetType()
{
	return SJ_PLGUIN_TYPE_FEATURE;
}

EXPORT_FNT_MARCO int GetInfo(std::string& Info)
{
#ifdef _DEBUG
	Info="AreaDivision feature ($Revision$) (Debug)";
#else
	Info="AreaDivision feature ($Revision$)";
#endif
	return SJ_MFC_DIALOG_SETUP;
}

#define INI_KEY "AreaDivisionPlugin"
#define INI_MIN_AREA "MinArea"
#define INI_AV_AREA "AvArea"
#define INI_ROUND "Round"

EXPORT_FNT_MARCO int SetupDll(const char *iniName)
{
	// Check that we have alocated memory for the name
	if(!iniName)return 0;
	// FileName of the description INI file with information about images to be loaded from the disk
	CSJIniFile IniConfig;

	std::string strIniFN=iniName;

	IniConfig.SetPath(strIniFN);
	IniConfig.ReadFile();
	
	// If we have this value in INI file load it and show it in the window
	int iMinArea=IniConfig.GetValueI(INI_KEY,INI_MIN_AREA);
	int iAvArea=IniConfig.GetValueI(INI_KEY,INI_AV_AREA);
	int iRound=IniConfig.GetValueI(INI_KEY,INI_ROUND);
	CAreaDivisionSetupDlg SetupDlg;
	SetupDlg.m_uiAvArea=iAvArea;
	SetupDlg.m_uiMinAreaForDiv=iMinArea;
	SetupDlg.m_yRound=iRound;
	if(SetupDlg.DoModal()==IDOK)
	{
		IniConfig.SetValueI(INI_KEY,INI_MIN_AREA,SetupDlg.m_uiMinAreaForDiv);
		IniConfig.SetValueI(INI_KEY,INI_AV_AREA,SetupDlg.m_uiAvArea);
		IniConfig.SetValueI(INI_KEY,INI_ROUND,SetupDlg.m_yRound);
		IniConfig.WriteFile();
		return 1;
	}
	return 0;

}

EXPORT_FNT_MARCO int ExtractFeature(CSJSpecimen &Specimen)
{
	std::string strh;
	GetInfo(strh);
	Specimen.AddLogMessage(strh+" is started");
	
	int iMinArea=Specimen.GetIniFile()->GetValueI(INI_KEY,INI_MIN_AREA);
	int iAvArea=Specimen.GetIniFile()->GetValueI(INI_KEY,INI_AV_AREA);
	int iRound=Specimen.GetIniFile()->GetValueI(INI_KEY,INI_ROUND);

	if(Specimen.GetVars()->GetValue("Area")=="")
	{
		MessageBox(NULL,"Need plugin for area calculations","Warning",MB_ABORTRETRYIGNORE|MB_ICONWARNING);
		return 0;
	}

	Specimen.ReportProgress(SJ_PLGUIN_TYPE_FEATURE,0);
	int iObjNum=Specimen.GetObjects()->GetLength();
	for(int iNum=0;iNum<iObjNum;iNum++)
	{
		CSJObjectInfo *ObjInfo=NULL;
		ObjInfo=Specimen.GetObjects()->GetObjectInfo(iNum);
		if(ObjInfo==NULL)ASSERT(0);
		int itvar=ObjInfo->GetValueI("Area");
		if(ObjInfo->GetValueI("Area")>iMinArea)
		{
			double dDiv=ObjInfo->GetValueI("Area")/(double)iAvArea;
			if(iRound) dDiv=ceil(dDiv);
				else dDiv=floor(dDiv);
			if(dDiv>1)ObjInfo->SetValue("SplitOnTo",dDiv);
		}

		// Report status
		Specimen.ReportProgress(SJ_PLGUIN_TYPE_FEATURE,(float)(iNum*100*0.7)/(float)iObjNum);
		if(Specimen.IsAborted())break;
	}
	CSJObjectInfoList NewList;
	for(int iCount=0;iCount<Specimen.GetObjects()->GetLength();iCount++)
	{
		CSJObjectInfo *ObjInfo=Specimen.GetObjects()->GetObjectInfo(iCount);if(ObjInfo==NULL)ASSERT(0);
		if(ObjInfo->HaveValue("SplitOnTo"))
		{
			int iSplitOnTo=ObjInfo->GetValueI("SplitOnTo");
			ObjInfo->DeleteValue("SplitOnTo");
			int iNewWidth=(int)floor(ObjInfo->Rect.Width()/iSplitOnTo);
			int iNewHeight=0;
			if(iNewWidth<1)
			{
				iNewHeight=(int)floor(ObjInfo->Rect.Height()/iSplitOnTo);
				iNewWidth=0;
				if(iNewHeight<1)continue;
			}
			for(int i=0;i<iSplitOnTo;i++)
			{
				CSJObjectInfo NewInfo(*ObjInfo);
				CSJBuffer *mask=NULL;
				// Divide Rect
				if(iNewWidth!=0)
				{
					NewInfo.Rect.m_iLeft=ObjInfo->Rect.m_iLeft+iNewWidth*i;
					NewInfo.Rect.m_iRight=ObjInfo->Rect.m_iLeft+iNewWidth*(i+1);
					mask=NewInfo.GetBinaryMap();
					mask->Crop(iNewWidth*i,0,iNewWidth*(i+1),mask->GetHeight());
				}
				if(iNewHeight!=0)
				{
					NewInfo.Rect.m_iTop=ObjInfo->Rect.m_iTop+iNewHeight*i;
					NewInfo.Rect.m_iBottom=ObjInfo->Rect.m_iBottom+iNewHeight*(i+1);
					mask=NewInfo.GetBinaryMap();
					mask->Crop(0,iNewHeight*i,mask->GetWidth(),iNewHeight*(i+1));
				}
				NewInfo.SetValue("FromSplit","AreaDivision");
				//Calculate area for the new bject
				int iNewArea=0;
				for(int iY=0;iY<NewInfo.GetBinaryMap()->GetHeight();iY++)
					for(int iX=0;iX<NewInfo.GetBinaryMap()->GetWidth();iX++)
						if(NewInfo.GetBinaryMap()->GetByteValue(iX,iY)!=0)iNewArea++;
				ObjInfo->SetValue("Area",iNewArea);
				NewList.Add(NewInfo);
			}
			ObjInfo->SetValue("Deleted",1);
		}
	}
	// Now delete all objects that has to be deleted
	iCount=0;
	while(iCount<Specimen.GetObjects()->GetLength())
		if(Specimen.GetObjects()->GetObjectInfo(iCount)->HaveValue("Deleted"))
		{
			Specimen.GetObjects()->Delete(iCount);
			iCount=0;
		}
		else iCount++;
	// Now add from the NewList
	int it=NewList.GetLength();
	int it2=Specimen.GetObjects()->GetLength();
	for(iCount=0;iCount<NewList.GetLength();iCount++)
	{
		CSJObjectInfo oi(*NewList.GetObjectInfo(iCount));
		Specimen.GetObjects()->Add(oi);
	}
	int it3=Specimen.GetObjects()->GetLength();
	Specimen.ReportProgress(SJ_PLGUIN_TYPE_FEATURE,100);
	Specimen.GetVars()->SetValue("AreaDivision",1);
	return 1;
}
