// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
//$Header: c:\\users\\sj\\CVS/Thesis/PlugIns/Features/Center/Center.cpp,v 1.5 2002/05/27 22:29:35 sj Exp $
// Center.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include <afxdllx.h>

#include "../../../Interfaces/Interfaces_def.h"

static AFX_EXTENSION_MODULE CenterDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("CENTER.DLL Initializing!\n");
		
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(CenterDLL, hInstance))
			return 0;

		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

		new CDynLinkLibrary(CenterDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("CENTER.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(CenterDLL);
	}
	return 1;   // ok
}

EXPORT_FNT_MARCO int GetType()
{
	return SJ_PLGUIN_TYPE_FEATURE;
}

EXPORT_FNT_MARCO int GetInfo(std::string& Info)
{
#ifdef _DEBUG
	Info="Center feature ($Revision: 1.5 $)(Debug)";
#else
	Info="Center feature ($Revision: 1.5 $)";
#endif
	
	return SJ_MFC_DIALOG_SETUP;
}

EXPORT_FNT_MARCO int SetupDll(const char *iniName)
{
	return 1;
}

// Find area of an iNum object
EXPORT_FNT_MARCO int ExtractFeature(CSJSpecimen &Specimen)
{
	Specimen.ReportProgress(SJ_PLGUIN_TYPE_FEATURE,0);
	int iObjNum=Specimen.GetObjects()->GetLength();
	for(int iNum=0;iNum<iObjNum;iNum++)
	{
		int iArea=0;
		CSJObjectInfo *ObjInfo=NULL;
		ObjInfo=Specimen.GetObjects()->GetObjectInfo(iNum);
		int iCX=(ObjInfo->Rect.Width())/2+ObjInfo->Rect.m_iLeft;
		int iCY=(ObjInfo->Rect.Height())/2+ObjInfo->Rect.m_iTop;
		ObjInfo->SetValue("CenterX",iCX);
		ObjInfo->SetValue("CenterY",iCY);
		Specimen.ReportProgress(SJ_PLGUIN_TYPE_FEATURE,(iNum*100)/(float)iObjNum);
	}
	Specimen.GetVars()->SetValue("Center",1);
	return 1;
}
