// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
//$Header: c:\\users\\sj\\CVS/Thesis/PlugIns/Features/MinLimit/MinLimit.cpp,v 1.2 2002/04/12 14:17:00 sj Exp $
// This's a template for Feature Plug-In.

#include "stdafx.h"
#include <afxdllx.h>

#include "../../../Interfaces/Interfaces_def.h"
#include "MinLimitDlg.h"

static AFX_EXTENSION_MODULE MinLimitDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	UNREFERENCED_PARAMETER(lpReserved);
	if (dwReason == DLL_PROCESS_ATTACH){
		TRACE0("MinLimit.DLL Initializing!\n");
		if (!AfxInitExtensionModule(MinLimitDLL, hInstance))return 0;
		new CDynLinkLibrary(MinLimitDLL);}
	else if (dwReason == DLL_PROCESS_DETACH){
		TRACE0("MinLimit.DLL Terminating!\n");
		AfxTermExtensionModule(MinLimitDLL);}
	return 1;
}

EXPORT_FNT_MARCO int GetType()
{
	return SJ_PLGUIN_TYPE_FEATURE;
}

EXPORT_FNT_MARCO int GetInfo(std::string& Info)
{
#ifdef _DEBUG
	Info="MinLimit feature ($Revision: 1.2 $) (Debug)";
#else
	Info="MinLimit feature ($Revision: 1.2 $)";
#endif
	return SJ_MFC_DIALOG_SETUP;
}

#define INI_KEY "MinLimit"
#define INI_VALUENAME "Area"

EXPORT_FNT_MARCO int SetupDll(const char *iniName)
{
	// Check that we have alocated memory for the name
	if(!iniName)return 0;
	// FileName of the description INI file with information about images to be loaded from the disk
	CSJIniFile IniConfig;

	std::string strIniFN=iniName;

	IniConfig.SetPath(strIniFN);
	IniConfig.ReadFile();
	
	// If we have this value in INI file load it and show it in the window
	int iMinAreaLimit=IniConfig.GetValueI(INI_KEY,INI_VALUENAME);
	
	CMinLimitDlg SetupDlg;
	SetupDlg.m_iMinAreaLimit=iMinAreaLimit;
	if(SetupDlg.DoModal()==IDOK)
	{
		IniConfig.SetValueI(INI_KEY,INI_VALUENAME,SetupDlg.m_iMinAreaLimit);
		IniConfig.WriteFile();
		return 1;
	}
	return 0;
}

EXPORT_FNT_MARCO int ExtractFeature(CSJSpecimen &Specimen)
{
	std::string strh;
	GetInfo(strh);
	Specimen.AddLogMessage(strh+" is started");
	Specimen.ReportProgress(SJ_PLGUIN_TYPE_FEATURE,0);
	int iMinAreaLimit=Specimen.GetIniFile()->GetValueI(INI_KEY,INI_VALUENAME);
	if(Specimen.GetVars()->GetValue("Area")=="")
	{
		MessageBox(NULL,"Need plugin for area calculations","Warning",MB_ABORTRETRYIGNORE|MB_ICONWARNING);
		return 0;
	}
	int iObjNum=Specimen.GetObjects()->GetLength();
	int iCount=0;
	for(int iNum=0;iNum<iObjNum;iNum++)
	{
		CSJObjectInfo *ObjInfo=Specimen.GetObjects()->GetObjectInfo(iNum);if(ObjInfo==NULL)ASSERT(0);

		if(iMinAreaLimit>ObjInfo->GetValueI("Area"))
		{
			ObjInfo->SetValue("Deleted",1);
			iCount++;
		}
		// Report status
		Specimen.ReportProgress(SJ_PLGUIN_TYPE_FEATURE,((iNum*100)/(float)iObjNum));
		if(Specimen.IsAborted())break;
	}
	Specimen.AddLogMessage(Format("%d cells removed because of the size",iCount));
	if(Specimen.IsAborted())return 0;
	// Delete info about bad objects
	iCount=0;
	while(iCount<Specimen.GetObjects()->GetLength())
		if(Specimen.GetObjects()->GetObjectInfo(iCount)->HaveValue("Deleted"))
		{
			Specimen.GetObjects()->Delete(iCount);
			iCount=0;
		}
		else iCount++;
	Specimen.GetVars()->SetValue("MinLimit",1);
	GetInfo(strh);
	Specimen.AddLogMessage(strh+" is normally finished");
	return 1;
}
