// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
// MorphologyOpSetupDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MorphologyOpSetupDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMorphologyOpSetupDlg dialog


CMorphologyOpSetupDlg::CMorphologyOpSetupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMorphologyOpSetupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMorphologyOpSetupDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CMorphologyOpSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMorphologyOpSetupDlg)
	DDX_Control(pDX, IDC_MORPHOLOGYOP_SETUP_DLG_LIST_SEQUENCE, m_ctrlLBSequence);
	DDX_Control(pDX, IDC_MORPHOLOGYOP_SETUP_DLG_EDIT_KERNEL, m_ctrlEditKernel);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMorphologyOpSetupDlg, CDialog)
	//{{AFX_MSG_MAP(CMorphologyOpSetupDlg)
	ON_BN_CLICKED(IDC_MORPHOLOGYOP_SETUP_DLG_BTN_EROSION, OnMorphologyopSetupDlgBtnErosion)
	ON_BN_CLICKED(IDC_MORPHOLOGYOP_SETUP_DLG_BTN_DILATION, OnMorphologyopSetupDlgBtnDilation)
	ON_BN_CLICKED(IDC_MORPHOLOGYOP_SETUP_DLG_BTN_REMOVE, OnMorphologyopSetupDlgBtnRemove)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMorphologyOpSetupDlg message handlers

void CMorphologyOpSetupDlg::OnMorphologyopSetupDlgBtnErosion() 
{
	m_ctrlLBSequence.AddString("Erosion");	
}

void CMorphologyOpSetupDlg::OnMorphologyopSetupDlgBtnDilation() 
{
	m_ctrlLBSequence.AddString("Dilation");
}

void CMorphologyOpSetupDlg::OnMorphologyopSetupDlgBtnRemove() 
{
	if(m_ctrlLBSequence.GetCount()<=0 || m_ctrlLBSequence.GetCurSel()<0)return;
	m_ctrlLBSequence.DeleteString(m_ctrlLBSequence.GetCurSel());
}

void CMorphologyOpSetupDlg::OnOK() 
{
	m_strSequence="";
	for (int i=0;i<m_ctrlLBSequence.GetCount();i++)
	{
		CString str;
		m_ctrlLBSequence.GetText(i,str);
		if(str=="Erosion")m_strSequence+="E";
		if(str=="Dilation")m_strSequence+="D";
	}
	CString str;
	m_ctrlEditKernel.GetWindowText(str);
	m_strKernel="";
	for(i=0;i<str.GetLength();i++)
	{
		char ch=str.GetAt(i);
		if(ch!=13 && ch!=32 && ch!=10)
			if( ch=='0' || ch=='1' || ch==',' || ch==';')
				m_strKernel+=ch;
			else
			{
				MessageBox("Please use only symbols: '1','0',',',';' and enter for Kenel","Error",MB_ICONWARNING);
				return;
			}
	}
	if(m_strKernel.GetLength()>9999)
	{
		MessageBox("Kernel is too big, should be less then 100x100","Error",MB_ICONWARNING);
		return;
	}

	CDialog::OnOK();
}

BOOL CMorphologyOpSetupDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	// Now fill the sequence
	for(int i=0;i<m_strSequence.GetLength();i++)
		switch(m_strSequence[i])
		{
			case 'E': 
						m_ctrlLBSequence.AddString("Erosion");
						break;
			case 'D':
						m_ctrlLBSequence.AddString("Dilation");
						break;
			default:	
						break;
		}
	// Now fill the kernel
	int iPos=0;
	while(iPos>=0)
	{
		iPos=m_strKernel.Find(';',iPos);
		if(iPos<0)continue;
		iPos++;
		m_strKernel.Insert(iPos,10);
		m_strKernel.Insert(iPos,13);
	}
	m_ctrlEditKernel.SetWindowText(m_strKernel);
	m_ctrlLBSequence.SetCurSel(0);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
