// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
//$Header: c:\\users\\sj\\CVS/Thesis/PlugIns/Features/SaveLoadObj/SaveLoadObj.cpp,v 1.1 2002/05/08 17:04:26 sj Exp $
// This's a template for Feature Plug-In.


// Add "../../../Interfaces/Interfaces.lib" to the Project Settings->Link->object/library modules
// Add "copy Debug\SaveLoadObj.dll ..\..\..\Amors\PlugIns\SaveLoadObjD.dll"
// to the Project Settings->Post-build step

// Non zero value returned by any function means a successful finishing


#include "stdafx.h"
#include <afxdllx.h>
#include <fstream>
#include <iomanip>

#include "../../../Interfaces/Interfaces_def.h"

static AFX_EXTENSION_MODULE SaveLoadObjDLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	UNREFERENCED_PARAMETER(lpReserved);
	if (dwReason == DLL_PROCESS_ATTACH){
		TRACE0("SaveLoadObj.DLL Initializing!\n");
		if (!AfxInitExtensionModule(SaveLoadObjDLL, hInstance))return 0;
		new CDynLinkLibrary(SaveLoadObjDLL);}
	else if (dwReason == DLL_PROCESS_DETACH){
		TRACE0("SaveLoadObj.DLL Terminating!\n");
		AfxTermExtensionModule(SaveLoadObjDLL);}
	return 1;
}

EXPORT_FNT_MARCO int GetType()
{
	return SJ_PLGUIN_TYPE_FEATURE;
}

EXPORT_FNT_MARCO int GetInfo(std::string& Info)
{
#ifdef _DEBUG
	Info="SaveLoadObj feature ($Revision: 1.1 $) (Debug)";
#else
	Info="SaveLoadObj feature ($Revision: 1.1 $)";
#endif
	return SJ_MFC_DIALOG_SETUP;
}

#define SAVE_LOAD_OBJ_MODE "SAVE_LOAD_OBJ_MODE"
#define SAVE_LOAD_OBJ_FN "SAVE_LOAD_OBJ_FN"
#define SAVE_LOAD_OBJ_INI_KEY "SAVE_LOAD_OBJ"
EXPORT_FNT_MARCO int SetupDll(const char *iniName)
{
	if(!iniName)return 0;
	CSJIniFile IniConfig;
	std::string strIniFN=iniName;
	IniConfig.SetPath(strIniFN);
	IniConfig.ReadFile();
	// Ask if user wants to save or load data
	bool ySaveData=false;
	if(IniConfig.GetValueI(SAVE_LOAD_OBJ_INI_KEY,SAVE_LOAD_OBJ_MODE)!=0)ySaveData=true;
	int iRes=MessageBox(NULL,"Press Yes to save information.\nPress No to load information.\nDo you want to save data about objects?","SOMDB Setup Q1",MB_YESNO |MB_ICONQUESTION);
	if(iRes==IDYES) ySaveData=true;
	else ySaveData=false;
	IniConfig.SetValueI(SAVE_LOAD_OBJ_INI_KEY,SAVE_LOAD_OBJ_MODE,ySaveData);
	std::string strFName=IniConfig.GetValue(SAVE_LOAD_OBJ_INI_KEY,SAVE_LOAD_OBJ_FN);
	// Find a path to the file with information
	MessageBox(NULL,"Please, choose the file to save/load information","SOMDB Setup Q1",MB_OK |MB_ICONINFORMATION);
	CFileDialog openDlg(true, "*.ini", strFName.data(), OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
						"Text files(*.txt)|*.txt|All Files (*.*)|*.*|");
	if (openDlg.DoModal() == IDOK)strFName=openDlg.GetPathName().GetBuffer(openDlg.GetPathName().GetLength());
	IniConfig.SetValue(SAVE_LOAD_OBJ_INI_KEY,SAVE_LOAD_OBJ_FN,strFName);
	IniConfig.WriteFile();
	return 1;
}

EXPORT_FNT_MARCO int ExtractFeature(CSJSpecimen &Specimen)
{
	Specimen.ReportProgress(SJ_PLGUIN_TYPE_FEATURE,0);
	std::string strh;
	GetInfo(strh);
	Specimen.AddLogMessage(strh+" is started");
	bool ySaveData=false;
	if(Specimen.GetIniFile()->GetValueI(SAVE_LOAD_OBJ_INI_KEY,SAVE_LOAD_OBJ_MODE)!=0)ySaveData=true;
	std::string strFName=Specimen.GetIniFile()->GetValue(SAVE_LOAD_OBJ_INI_KEY,SAVE_LOAD_OBJ_FN);
	CSJIniFile ObjectF;
	ObjectF.SetPath(strFName);
	if(ySaveData)
	{
		Specimen.AddLogMessage("Saving data");
		// Save all variables
		for(int i=0;i<Specimen.GetVars()->GetNumVars();i++)
			ObjectF.SetValue("Vars",Specimen.GetVars()->GetNameAt(i),Specimen.GetVars()->GetValueAt(i));
		// Now save all objects
		int iObjNum=Specimen.GetObjects()->GetLength();
		for(int iNum=0;iNum<iObjNum;iNum++)
		{
			CSJObjectInfo *ObjInfo=Specimen.GetObjects()->GetObjectInfo(iNum);if(ObjInfo==NULL)ASSERT(0);

			//Save all information about the object
			std::string strKey=Format("Obj%d",iNum);
			// Save rectangle
			ObjectF.SetValueI(strKey,"internalRect_iLeft",ObjInfo->Rect.m_iLeft);
			ObjectF.SetValueI(strKey,"internalRect_iRight",ObjInfo->Rect.m_iRight);
			ObjectF.SetValueI(strKey,"internalRect_iTop",ObjInfo->Rect.m_iTop);
			ObjectF.SetValueI(strKey,"internalRect_iBottom",ObjInfo->Rect.m_iBottom);
			// Go through all variables
			for(int i=0;i<ObjInfo->GetNumVars();i++)
				ObjectF.SetValue(strKey,ObjInfo->GetNameAt(i),ObjInfo->GetValueAt(i));
			// Report status
			Specimen.ReportProgress(SJ_PLGUIN_TYPE_FEATURE,(iNum*100)/(float)iObjNum);
			if(Specimen.IsAborted())break;
		}
		ObjectF.WriteFile();
	}
	else
	{
		Specimen.AddLogMessage("Loading data");
		ObjectF.ReadFile();
		// Clear existed objects and vars
		Specimen.GetObjects()->Clear();
		Specimen.GetVars()->Clear();
		// Load Vars
		for(int i=0;i<ObjectF.GetNumValues("Vars");i++)
			Specimen.GetVars()->SetValue(ObjectF.GetVarName("Vars",i),ObjectF.GetValue("Vars",ObjectF.GetVarName("Vars",i)));
		// Load all objects
		int iNum=0;
		std::string strKey=Format("Obj%d",iNum);
		while(ObjectF.HaveKey(strKey))
		{
			CSJObjectInfo ObjInfo;
			ObjInfo.Rect.m_iLeft=ObjectF.GetValueI(strKey,"internalRect_iLeft");
			ObjInfo.Rect.m_iRight=ObjectF.GetValueI(strKey,"internalRect_iRight");
			ObjInfo.Rect.m_iTop=ObjectF.GetValueI(strKey,"internalRect_iTop");
			ObjInfo.Rect.m_iBottom=ObjectF.GetValueI(strKey,"internalRect_iBottom");
			for(int i=0;i<ObjectF.GetNumValues(strKey);i++)
				ObjInfo.SetValue(ObjectF.GetVarName(strKey,i),ObjectF.GetValue(strKey,ObjectF.GetVarName(strKey,i)));
			Specimen.GetObjects()->Add(ObjInfo);
			iNum++;
			strKey=Format("Obj%d",iNum);
		}
		Specimen.AddLogMessage(Format("Loaded %d objects",iNum));
	}
	Specimen.GetVars()->SetValue("SaveLoadObj",1);
	GetInfo(strh);
	Specimen.AddLogMessage(strh+" is normally finished");
	return 1;
}
