// Copyright (c) 2002 Oleksandr Shyrokov 
// E-mail: olexander_shyrokov@yahoo.com
// WEB:	http://sjcomp.virtualave.net/thesis/
// WEB:	http://www.ece.unh.edu/svpal/
// 
// Permission to use, copy, modify and distribute the contests of this code
// for non-commercial purpose is hereby granted without fee, provided
// that (i) the above copyright notices and this permission notice appear in
// all copies of the software and related documentation, and (ii) the name of
// Oleksandr Shyrokov may not be used in any advertising or
// publicity relating to the software without the specific, prior written
// permission of Oleksnadr Shyrokov.
// 
// For commercial use of the source code or parts of the source code,
// written permission of Oleksandr Shyrokov is required!
// 
// THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
// WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
// 
// IN NO EVENT SHALL OLEKSANDR SHYROKOV BE LIABLE FOR
// ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
// OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
// WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF 
// LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE 
// OF THIS SOFTWARE.
// 
//$Header: c:\\users\\sj\\CVS/Thesis/PlugIns/ObjSep/RegGrow/RegGrow.cpp,v 1.5 2002/04/19 18:18:21 sj Exp $

// Non zero value returned by any function means a successful finishing

#include "stdafx.h"		// Should be used in order to have precomipled headers
#include <afxdllx.h>		// It's a dll with MFC extension
// String support
#pragma warning(disable:4786)
#include <string>
#include <vector>
#include <utility>


// Definitions of interface objects
#include "../../../Interfaces/Interfaces_def.h"

// If you want to store preferences in the global Ini file
// It's convinuent to use such definitions
#define RegGrow_INI_SECTION "RegGrow_CONFIG"
#define RegGrow_VARIABLE1 "RegGrow_VARIABLE1"
#define RegGrow_VARIABLE2 "RegGrow_VARIABLE2"

static AFX_EXTENSION_MODULE RegGrowDLL = { NULL, NULL };

// Standard initializing routin.
extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("RegGrow.DLL Initializing!\n");
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(RegGrowDLL, hInstance))
			return 0;
		new CDynLinkLibrary(RegGrowDLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("RegGrow.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(RegGrowDLL);
	}
	return 1;   // ok
}

EXPORT_FNT_MARCO int GetType()
{
// Should return type of the DLL, see AllConstants.h in Interface library for
// all defined types in "enum Plugins_types"
	return SJ_PLGUIN_TYPE_OBJ_SEP;
}

EXPORT_FNT_MARCO int GetInfo(std::string& Info)
{
#ifdef _DEBUG
	Info="RegGrow ver $Revision: 1.5 $ (Debug)";
#else
	Info="RegGrow ver $Revision: 1.5 $ ";
#endif

// If you want to use SetupDlg you must return 	
// SJ_MFC_DIALOG_SETUP value from this function
//	return SJ_MFC_DIALOG_SETUP;
// Otherwise:
	return SJ_NO_SETUP_DIALOG;
}

EXPORT_FNT_MARCO int SetupDll(const char *iniName)
{
	// Use this object to save preferences
	CSJIniFile IniConfig;
	// Check that we have alocated memory for the name
	if(!iniName)return 0;
	std::string strIniFN=iniName;

	IniConfig.SetPath(strIniFN);
	IniConfig.ReadFile();

//	CYourSetupDlg SetupDlg;
	// If we have this value in INI file load it and show it in the window
	// Read varibles from INI file and initialize dialog variables
//	SetupDlg.m_strVariable1=IniConfig.GetValue(RegGrow_INI_SECTION,RegGrow_VARIABLE1).data();
//	SetupDlg.m_iVariable2=IniConfig.GetValueI(RegGrow_INI_SECTION,RegGrow_VARIABLE2);
//	if(SetupDlg.DoModal()==IDOK)
	{
		// If dialog has been successfully closed write  these values to the Ini File
//		IniConfig.SetValue(RegGrow_INI_SECTION,RegGrow_VARIABLE1,SetupDlg.m_strVariable1.GetBuffer(SetupDlg.m_strVariable1.GetLength()));
//		IniConfig.SetValueI(RegGrow_INI_SECTION,RegGrow_VARIABLE2,SetupDlg.m_iVariable2);
//		IniConfig.WriteFile();
		// Non zero value means a successful setup (used in Reaserch mode)
	return 1;
	}
	return 0;
}

// Initializes whatever you need for work. Should be called once, or in pair with Done
EXPORT_FNT_MARCO int Init(CSJSpecimen &Specimen)
{
	// Put any code for initialization here

	return 1;
}

// Shuts down hardware or whatever you need to do here. Cleaning and so on...
EXPORT_FNT_MARCO int Done(CSJSpecimen &Specimen)
{
	// Put any code for deinitialization here

	return 1;
}

// This function will try to grow a region in a gray scale image based on
// min and max thresholds and a seed pixel.  Since the boundries of a cell
// tend to be darker then the middle sections the routine will perform a fill
// in of the pixels.  If the resultant region is too small the region will be
// removed from the segmented image.
void Process_region(CSJBuffer* Seg_buffer,
					CSJBuffer* Processed_buffer,
					CSJBuffer* InputBuffer,
					double dMin_thresh,
					double dMax_thresh,
					double dImage_std,
					int iSeed_r,
					int iSeed_c,
					int &iRegion_counter)
{
// Setup for the region growing process by setting up the stack and a buffer
// area to keep track of the pixels in the region.
	typedef std::vector<std::pair<int,int> > stack_type;
	stack_type Stack;
	stack_type Pixels;
	Stack.reserve(100);
	Pixels.reserve(2000);

	// Increment the region counter to indicate a new region exists.
	iRegion_counter++;
	
	// Orginal seed must be saved in case the region is too small.
	int iFirst_r = iSeed_r;
	int iFirst_c = iSeed_c;

	// Set the seed pixel for processing and clear the stack pointer and pixel counter.
	Seg_buffer->SetValue(iSeed_c,iSeed_r,iRegion_counter);
	Processed_buffer->SetValue(iSeed_c,iSeed_r,1);
	WORD iLast_seed= InputBuffer->GetValue(iSeed_c,iSeed_r);
	//int iStack_ptr=0;
	//int iPixel_counter=0;

	// Setup initial min and max values for both the row and column.
	int iR_min=10000;
	int iR_max=-10000;
	int iC_min= 10000;
	int iC_max=-10000;

	while(1)
	{
		//Setup the boundries for checking if a connectivity exists.
		int iRow_min=iSeed_r-1;
		if(iRow_min<0)iRow_min=0;
		int iRow_max=iSeed_r+1;
		if(iRow_max>=InputBuffer->GetHeight())iRow_max=InputBuffer->GetHeight()-1;
		int iCol_min=iSeed_c-1;
		if(iCol_min<0)iCol_min=0;
		int iCol_max=iSeed_c+1;
		if(iCol_max>=InputBuffer->GetWidth())iCol_max=InputBuffer->GetWidth()-1;
		// Check the neighbors of the cell of interest to see if they are set.
		// If so then mark the pixel as part of the region and put the location
		// of the pixel on the stack.

		for(int iR=iRow_min;iR<=iRow_max;iR++)
		{
			for(int iC=iCol_min;iC<=iCol_max;iC++)
			{
				if((Processed_buffer->GetValue(iC,iR)==0) && (Seg_buffer->GetValue(iC,iR)==0))
				{
					if(	InputBuffer->GetValue(iC,iR)>Round(iLast_seed-dImage_std) &&
						InputBuffer->GetValue(iC,iR)<Round(iLast_seed+dImage_std))
					{
						//iStack_ptr++;
						Stack.push_back(std::make_pair(iC,iR));
						// Keep track of the bounding box of the region on the fly.
						if(iR>iR_max)iR_max=iR;
						if(iR<iR_min)iR_min=iR;
						if(iC>iC_max)iC_max=iC;
						if(iC<iC_min)iC_min=iC;
						// Mark all pixels of the same region with the same region number
						Seg_buffer->SetValue(iC,iR,iRegion_counter);
						// Increment the pixel counter and save the pixel location in
						// in case the region needs to be removed.
						//iPixel_counter++;
						Pixels.push_back(std::make_pair(iC,iR));
					}
				}
				Processed_buffer->SetValue(iC,iR,1);
			}
		}
		// If the stack is not empty then more processing is needed.  Pop the
		// stack and process on the new seed.
		if(!Stack.empty())
		{
			iSeed_c=Stack[Stack.size()-1].first;
			iSeed_r=Stack[Stack.size()-1].second;

//			iSeed_c=Stack[iStack_ptr].first;
//			iSeed_r=Stack[iStack_ptr].second;
			//iLast_seed = InputBuffer->GetValue(iSeed_c,iSeed_r);    
			Stack.pop_back();
		}
		else
			break;
	}

	if(Pixels.size()>=10)
	{
		for(int iR_index=iR_min;iR_index<=iR_max;iR_index++)
		{
			int iStart=0;
			int iStop=0;
			// Determine Rightmost Pixel
			int iC_index=iC_min;
			while(iC_index<iC_max)
			{
				if(Seg_buffer->GetValue(iC_index,iR_index)==iRegion_counter)
				{
					iStart = iC_index;
					iC_index = iC_max;
				}
				iC_index++;
			}

			// Determine Leftmost Pixel
			iC_index=iC_max;
			while(iC_index>iC_min)
			{
				if(Seg_buffer->GetValue(iC_index,iR_index)==iRegion_counter)
				{
					iStop=iC_index;
					iC_index=iC_min;
				}
				iC_index--;
			}

			// For each row fill from left to right
			if((iStart!=0)&&(iStop!=0))
			{
				for(iC_index=iStart;iC_index<=iStop;iC_index++)
					if(Seg_buffer->GetValue(iC_index,iR_index)==0)
					{
						Seg_buffer->SetValue(iC_index,iR_index,iRegion_counter);
						Processed_buffer->SetValue(iC_index,iR_index,1);
						//iPixel_counter++;
						Pixels.push_back(std::make_pair(iC_index,iR_index));
					}
			}
		}
		for(int iC_index=iC_min;iC_index<=iC_max;iC_index++)
		{
			int iStart=0;
			int iStop=0;
			// Determine Uppermost Pixel
			int iR_index=iR_min;
			while(iR_index<iR_max)
			{
				if(Seg_buffer->GetValue(iC_index,iR_index)==iRegion_counter)
				{
					iStart=iR_index;
					iR_index=iR_max;
				}
				iR_index++;
			}

			// Determine Bottommost Pixel
			iR_index=iR_max;
			while(iR_index>iR_min)
			{
				if(Seg_buffer->GetValue(iC_index,iR_index)==iRegion_counter)
				{
					iStop=iR_index;
					iR_index=iR_min;
				}
				iR_index--;
			}

			// For each column fill from top to bottom
			if((iStart!=0)&&(iStop!=0))
			{
				for(iR_index=iStart;iR_index<=iStop;iR_index++)
					if(Seg_buffer->GetValue(iC_index,iR_index)==0)
					{
						Seg_buffer->SetValue(iC_index,iR_index,iRegion_counter);
						Processed_buffer->SetValue(iC_index,iR_index,1);
						//iPixel_counter++;
						Pixels.push_back(std::make_pair(iC_index,iR_index));
					}
			}
		}
	}

	// Remove all regions which are too small.
//	if(!Pixels.empty() && Pixels.size()<100)
//	{
//		for(int iIndex=0;iIndex<Pixels.size();iIndex++)
//		{
//			int iC=Pixels[iIndex].first;
//			int iR=Pixels[iIndex].second;
//			Seg_buffer->SetValue(iC,iR,0);
//			Processed_buffer->SetValue(iC,iR,0);
//		}
//		Pixels.clear();
//		// Reset the region counter to the value it had at the call of the routine
//		iRegion_counter--;
//		// Clear the seed pixel of the segment image and the processed flag markers.
//		Processed_buffer->SetValue(iFirst_c,iFirst_r,0);
//		Seg_buffer->SetValue(iFirst_c,iFirst_r,0);
//	}
	return;
}


EXPORT_FNT_MARCO int Separate(CSJSpecimen &Specimen)
{
	// Variable to report progress in the module
	float fPorgress=0;
	// Assign reprort varialbe
	Specimen.ReportProgress(SJ_PLGUIN_TYPE_OBJ_SEP,fPorgress);
	int iNumOfImages=Specimen.GetImageList()->GetLength();
// Repeat this operation for all images in the list
	for(int iOriginalImage=0;iOriginalImage<iNumOfImages;iOriginalImage++)
	{
		// Will work only on the grayscale image, or the first buffer
		CSJBuffer* InputBuffer=Specimen.GetImageList()->GetImage(iOriginalImage)->GetGrayScaleImage();
		// In case if there's no image to work on
		if(InputBuffer==NULL)return 0;
		// In case if it's just small
		if(InputBuffer->GetWidth()<5 || InputBuffer->GetHeight()<5)return 0;
		// Determine some of the parameters of the input image.
		double	dImage_mean=InputBuffer->Mean2();
		double	dImage_std=InputBuffer->Std2();
		int		iImage_min=InputBuffer->Min();
		int		iImage_max=InputBuffer->Max();
		
		// Setup thresholds for processing regions.
		double dMin_thresh=iImage_min;
		double dMax_thresh=iImage_min+dImage_std;
		double dThresh=iImage_min+dImage_std;
		// Will be added to see binary image
		CSJImage ImRegGrow;

		// Setup initial conditions for processing regions.
		CSJBuffer Seg_buffer(*InputBuffer);
		Seg_buffer.ClearMemory();
		CSJBuffer Processed_buffer=Seg_buffer;
		int iRegion_counter=0;

		// Scan through the input image for items which cross over the threshold.
		// Once an item is found see if a region will grow at the seed pixel.
		double fProgressScale=(float)(100/(((dImage_mean- 2.5 * dImage_std)-(iImage_min+dImage_std))))/iNumOfImages;
		Specimen.ReportProgress(SJ_PLGUIN_TYPE_OBJ_SEP,(float)(fProgressScale*dThresh)+((100*iOriginalImage)/iNumOfImages));
		while(1)
		{
			if(Specimen.IsAborted())return 0;
			for(int iR_index = 1;iR_index<InputBuffer->GetHeight()-2;iR_index++)
			{
				for(int iC_index = 1;iC_index<InputBuffer->GetWidth()-2;iC_index++)
				{
					if(Seg_buffer.GetValue(iC_index,iR_index) == 0)
					{
						if(InputBuffer->GetValue(iC_index,iR_index)< dThresh)
						{
							int iSeed_c = iC_index;
							int iSeed_r = iR_index;
							Process_region(	&Seg_buffer,
											&Processed_buffer,
											InputBuffer,
											dMin_thresh,
											dMax_thresh,
											dImage_std,
											iSeed_r,
											iSeed_c,
											iRegion_counter);
							if(Specimen.IsAborted())return 0;
						} // If pixel crosses threshold
					}// check
				}// columns
			}// rows
			//Increase all thresholds and see if it is time to quit.
			dMin_thresh+=dImage_std;
			dMax_thresh+=dImage_std;
			dThresh+=dImage_std;
			Specimen.ReportProgress(SJ_PLGUIN_TYPE_OBJ_SEP,(float)(fProgressScale*dThresh)*iOriginalImage);
			if(dThresh>(dImage_mean- 2.5 * dImage_std))break;
			if(Specimen.IsAborted())break;
		}
		if(Specimen.IsAborted())return 0;
		// Now add this segmented image to the list
		ImRegGrow.Create(Seg_buffer.GetWidth(),Seg_buffer.GetHeight());
		ImRegGrow.GetGrayScaleImage()->Copy(Seg_buffer);
		Specimen.GetTempImages()->Add(ImRegGrow);
		Threshold(Seg_buffer,1);
		ImRegGrow.GetGrayScaleImage()->Copy(Seg_buffer);
		Specimen.GetTempImages()->Add(ImRegGrow);
		IncreaseDepth(Seg_buffer);
		Connectivity(&Seg_buffer);
		CSJObjectInfoList Objects;
		Find_Blobs(&Objects,&Seg_buffer);
		// Assign number of the image from which object was taken!
		for(int iNum=0;iNum<Objects.GetLength();iNum++)
		{
			Objects.GetObjectInfo(iNum)->SetValue("OriginalImage",iOriginalImage);
			// Now coppy all objects into main list
			Specimen.GetObjects()->Add(*Objects.GetObjectInfo(iNum));
		}
	}
	Specimen.GetVars()->SetValue("Region Growing",1);
	return 1;	
}
